{ UNIT _PCIVME  for a single PCICC2 System / ARW 1998,1999,2000
  Dieser Quelltext ist Public Domain.

  ---
  Interrup Handler ist aus der UNIT UART und an _PCIADA angepasst.
    http://www.fb15.uni-dortmund.de/voelker/tpfaq/tpfaq_34.html
    Unit UART - serielle I/O v3    07/91,08/92,01/93
    by Peter Mandrella, P.Mandrella@HOT.gun.de

  Ein PCIADA kann mit PCIADA_enable_irq fuer Interrupts aktiviert und mit
  PCIADA_disable_irq wieder freigegeben werden. Beim Aktivieren ist die
  PCIADA_Nr (default 0) und die intline-number erforderlich

  Das Deaktivieren ist nicht unbedingt noetig, sondern erfolgt falls
  noetig auch automatisch bei Programmende.
  ---
  Achtung! Der Interrup-Haendler arbeitet nur im DOS-MODE korrekt.
           In einem DOS-Fenster unter Windows95/98 kann es u.U zum
	   Sytemabsturz kommen.

  9.3.99   PCI9050 Address-Error mapping fuer PCI 9050 eingebaut
           siehe PCIVME-CD ...\PCI9050\ERRATA.PDF

  16.3.99  Unit CRT erzeugt bei Pentium II einen Runtime-Error
           Abhilfe: siehe PCIVME-CD ...\DOS\PASCAL\BPPATCH
  27.11.99 Modifiziert fuer CC32 Camac Controller

}
    {$B-,R-,S-,V-,F-,I-,A+}

    unit _pcic32x;
    interface
    uses crt,dos,_hexnum,_unreal;
    {$IFNDEF DPMI}
      const Seg0040 = $40;
    {$ENDIF}

    	  intcount   			: word = 0;

  TYPE   dateinametyp                   =  string [20];
         DateiTyp                       =  text;
         stringtyp                      =  string [25];


  var   IOBASE    	        	: word;  	(* MEMBASE = segment *)
        CC32BASE,MEMBASE_LCR            : longint;
        intline		      		: byte;
        cQ,cX,cC,cZ,cI,cL           	: boolean;
        ARW_SUBSYSTEM_ID            	: longint;
        error,adr_pcireg,vector     	: byte;
        ch                              : char;
        wdateiname                      : dateinametyp;
        wdat                            : dateityp;


  const CC32_stat               = $0;       (* offset *)
        filename                = 'PCIADA-C.TXT';

  procedure  rd_9050_pcireg        (var data   : longint;
                                    var error  : byte;
                                    plx_card_nr: byte);
  procedure  PCIADA_on;
  procedure  PCIADA_off;
  procedure  PCIADA_autoread_on;
  procedure  PCIADA_autoread_off;
  procedure  PCIADA_clr_timeovff;
  procedure  wr_ispl_stat;
  procedure  wr_plx_int_reg;
  procedure  wr_plx_cntrl_reg;

  Procedure PCICC32_tstandset(pciada_nr:byte;version:string);
  procedure PCIADA_enable_irq;            { PCIADA interrupt aktivieren.}
  procedure PCIADA_disable_irq;   	  { PCIADA interrupt de-aktivieren.}
  Procedure PCIADA_init;	          { PCIADA interrupt level definde}
  Procedure RD_vector(var vector:byte);

  Procedure cc32_res;				{ reset cc32}
  Procedure cc32_C;				{ (C) Clear }
  Procedure cc32_C_res_I;			{ (C) Clear + reset Inhibit }
  Procedure cc32_Z;				{ (Z) Initialize }
  Procedure cc32_Z_set_I;			{ (Z) Initialize + set Inhibit }
  Procedure cc32_set_I;   	          	{ set   Inhibit }
  Procedure cc32_res_I;   	        	{ reset Inhibit }
  Procedure cc32_tst_I;                  	{ test  Inhibit }
  Procedure cc32_res_LAMff;  	          	{ reset LAM-FF }
  Procedure cc32_tst_LAMff;                  	{ test  LAM-FF }
  Procedure cc32_set_LMall;                 	{ set   LAM-MASK all }
  Procedure cc32_res_LMall;                 	{ reset LAM-MASK all }
  Procedure cc32_set_LMbit (n    :byte);  	{ set   bit in LMASK }
  Procedure cc32_res_LMbit (n    :byte);  	{ reset bit in LMASK }
  Procedure cc32_wr_LMask(lmask :LongInt); 	{ write LamMask }
  Procedure cc32_wr_BMask(bmask :LongInt); 	{ write Broadcast Mask }

  Procedure cc32_rd_LAMmask(Var mask :LongInt); { read 24 bit LMASK}
  Procedure cc32_rd_LAMbus (Var lam  :LongInt); { read 24 bit LAM Dataway}
  Procedure cc32_rd_LAMand (Var lam  :LongInt); { read 24 bit LAM-AND}
  Procedure cc32_rd_Lamnot (Var lam  :LongInt); { read 24 bit LAM-NOT}
  Procedure cc32_rd_LED    (Var led  :LongInt); { read 24 bit LED and set cC and cZ}

  Procedure cc32_wr16      (n,a,f    :integer;  { write 16 bit data }
                                data :LongInt);
  Procedure cc32_wr16qx    (n,a,f    :integer;  { write 16 bit data and set CQ u.cX}
                                data :LongInt);
  Procedure cc32_wr24      (n,a,f    :integer;  { write 24 bit data }
                                data :LongInt);
  Procedure cc32_wr24qx    (n,a,f    :integer;  { write 24 bit data and set CQ u.cX }
                                data :LongInt);
  Procedure cc32_rd16      (n,a,f    :integer;  { read 16 Bit data }
		            var data :LongInt);
  Procedure cc32_rd16qx    (n,a,f    :integer;  { read 16 Bit data and set CQ u.cX }
		            var data :LongInt);
  Procedure cc32_rd24      (n,a,f    :integer;  { read 24 Bit data }
		            var data :LongInt);
  Procedure cc32_rd24qx    (n,a,f    :integer;  { read 24 Bit data and set CQ u.cX }
		            var data :LongInt);
  implementation  {-----------------------------------------------------}

  const	active     	: boolean = (false);
       	intmask     	: byte = $10;
      	intcontr2  	: boolean = (false);

  var 	oldvector      	: pointer;
       	exitsave   	: pointer;
	lnaf        	: word;
	ln,la,lf        : byte;

  procedure Initasm; assembler;
  asm
    xor ax, ax
    db 08Eh, 0E0h (* mov fs, ax *)
    db 08Eh, 0E8h (* mov gs, ax *)
  end;


  Procedure rd_9050_pcireg;
  var
  regah,rega,plxoffset                                 : byte;
  regdl,regdh,rebp,regsi,regdi,regds,reges             : word;
  regax,regbx,regcx                                    : word;
  regs: Registers;
  begin
    {test ob PCI-BIOS vorhanden?}
    plxoffset := data;
    error := 0;
    regs.ax := $b101;
    with regs do intr($1A,regs);
    with regs do
    begin
      regah := ah;
      regdh := dh;
      regdl := dl;
    end;
    if regah = 1 then  error :=1;
    if error = 0 then
    {test einheiten-ID + hersteller-ID}
    begin
      regs.ax := $b102;
      regs.cx := $2258; (* ARW ID from PLX for CC32 installaion*)
      regs.dx := $10b5;
      regs.si := plx_card_nr;
      with regs do intr($1A,regs);
      with regs do
      begin
        regah := ah;
        regbx := bx;
      end;
    end;
    if regah <> 0 then  error := 2;
    if error = 0 then
    begin
    {read lowword}
      regs.ax := $b109;
      regs.bx := regbx;
      regs.di := plxoffset + 2;
      with regs do intr($1A,regs);
      with regs do
      begin
        regax := ax;
        regcx := cx;
      end;
      if regah <> 0 then error := 3;
    end;
    if error = 0 then
    begin data := regcx;
      data := data shl 16;
      {read highword}
      regs.ax := $b109;
      regs.bx := regbx;
      regs.di := plxoffset;
      with regs do intr($1A,regs);
      with regs do
      begin
        regah := ah;
        regcx := cx;
      end;
      if regah <> 0 then error := 3;
      if error = 0 then data := data + regcx;
    end;
  end;

  Procedure wr_9050_pcireg  (var data   : longint;
                             var adr_pcireg   : byte;
                             plx_card_nr : byte);

  var regah,rega,plxoffset                                 : byte;
      regdl,regdh,rebp,regsi,regdi,regds,reges             : word;
      regax,regbx,regcx                                    : word;
      regs: Registers;
  begin
   {test einheiten-ID + hersteller-ID}
    regs.ax := $b102;
    regs.cx := $2258; (* ARW ID from PLX for CC32 installaion*)
    regs.dx := $10b5;
    regs.si := plx_card_nr;
    with regs do intr($1A,regs);
    with regs do
    begin
      regah := ah;
      regbx := bx;
    end;
    {write lowword}
    regs.ax := $b10c;
    regs.bx := regbx;
    regs.di := adr_pcireg; (* enthaelt adresse beim schreiben *)
    regs.cx := data;
    with regs do intr($1A,regs);
    with regs do
    begin
      regah := ah;
      cx := regcx;
    end;
    data := data shr 16;
    {write highword}
    regs.ax := $b10c;
    regs.bx := regbx;
    regs.di := adr_pcireg + 2;
    regs.cx := data;
    with regs do intr($1A,regs);
    with regs do
    begin
      regah := ah;
      cx := regcx;
    end;
  end;
  procedure goto_halt;
  begin;
    writeln(chr($07));
    close (wdat);
    writeln('PCICC32-Chek abort >> File PCIADA-C.TXT create !');
    writeln('press any key to exit');
    repeat until keypressed;ch := ReadKey;
    halt;
  end;
(*******************************************************************)
  procedure   PCICC32_tstandset(pciada_nr:byte;version:string);
  var         data,datax : longint;
              error : byte;
  begin
    Initasm; (* wichtig fuer _unreal.obj *)
    wdateiname := filename;
    assign (wdat,wdateiname );
    rewrite ( wdat);
    writeln(     version);
    writeln(wdat,version);

    (* test ARW SUB-ID *)
    data := $2c;
    rd_9050_pcireg(data,error,pciada_nr); (* PCI-Config.-Reg Adr $2c lesen *)
    ARW_SUBSYSTEM_ID := (data shr 16);
    if (error = 0) and (ARW_SUBSYSTEM_ID = $2258)
    then
    begin
      writeln(     'PCIADA-C #',pciada_nr,' with CC32-configuration found');
      writeln(wdat,'PCIADA-C #',pciada_nr,' with CC32-configuration found');
    end
    else
    begin
      if (ARW_SUBSYSTEM_ID <> $2258) and (error = 0) then
      begin
        writeln(     'PLX9050  #',pciada_nr,' is not a PCIADA Board !!!');
        writeln(wdat,'PLX9050  #',pciada_nr,' is not a PCIADA Board !!!');
      end;
      if error = 1 then
      begin
        writeln(     'PLX9050  #',pciada_nr,' no PCI-BIOS !!!');
        writeln(wdat,'PLX9050  #',pciada_nr,' no PCI-BIOS !!!');
      end;
      if error = 2 then
      begin
        writeln(     'PCIADA-C #',pciada_nr,' with CC32-configuration not found');
        writeln(wdat,'PCIADA-C #',pciada_nr,' with CC32-configuration not found');
        writeln;
        writeln(     'Use PLXEEP.EXE and reprogram PCIADA with CC32 in high memory!');
      end;
      if error = 3 then
      begin
        writeln(     'PLX9050  #',pciada_nr,' not found !!!');
        writeln(wdat,'PLX9050  #',pciada_nr,' not found !!!');
      end;
      if error > 1 then goto_halt;
    end;

    if (error = 0) and (ARW_SUBSYSTEM_ID = $2258) then
    begin
      (* PLX_IO-adresse lesen *)
      data := $14;
      rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $14 read *)
      IOBASE   := data and $0000fff0;
      if error = 0 then
      begin
        if (IOBASE and $00000080) = $00000000 then
        begin
          writeln(     'PCIADA-C #',pciada_nr,' IOBASE  LCRegister       = ',num2hex(IOBASE,4));
          writeln(wdat,'PCIADA-C #',pciada_nr,' IOBASE  LCRegister       = ',num2hex(IOBASE,4));
        end
        else
        begin
          data := $24;
          rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $24 read *)
          adr_pcireg := $14;
          wr_9050_pcireg(data,adr_pcireg,pciada_nr);(* PCI-Config.-Reg Adr $14 write *)
          data := $14;
          rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $14 read *)
          IOBASE   := data and $0000fff0;
          writeln(     'PCIADA-C #',pciada_nr,' IOBASE  address          = ',num2hex(IOBASE,4));
          writeln(wdat,'PCIADA-C #',pciada_nr,' IOBASE  address          = ',num2hex(IOBASE,4));
        end;
      end
      else
      begin
        writeln(     'PCIADA-C #',pciada_nr,' not found !');
        writeln(wdat,'PCIADA-C #',pciada_nr,' not found !');
        goto_halt;
      end;
    end;
    (* MEMBASE-LCR read -----------------------------------------------------------------   *)

    data := $10;
    rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $10 read *)
    MEMBASE_LCR := data and $fffffff0;
    if error = 0 then
    begin
      writeln(     'PCIADA-C #',pciada_nr,' MEMBASE LCRegister       = ',num2hex(MEMBASE_LCR,8));
      writeln(wdat,'PCIADA-C #',pciada_nr,' MEMBASE LCRegister       = ',num2hex(MEMBASE_LCR,8));
    end
    else
    begin
      writeln(     'PCIADA-C not found !');
      writeln(wdat,'PCIADA-C not found !');
      goto_halt;
    end;
    (* PCI_MEM-adresse lesen / $18=Adrspace 1/$1C= Adrspace 2 *)
    data := $1c;
    rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $10 read *)
    CC32BASE := data and $fffffff0;
    if error = 0 then
    begin
      writeln(     'PCIADA-C #',pciada_nr,' CC32BASE Adress          = ',num2hex(CC32BASE,8));
      writeln(wdat,'PCIADA-C #',pciada_nr,' CC32BASE Adress          = ',num2hex(CC32BASE,8));
    end
    else
    begin
      writeln(     'PCIADA-C not found !');
      writeln(wdat,'PCIADA-C not found !');
      goto_halt;
    end;
    (* PLX Interrupt Line lesen *)
    data := $3C;
    rd_9050_pcireg(data,error,pciada_nr); (* PCI-Config.-Reg Adr $3c read *)
    INTLINE   := data and $000000ff;
    if error = 0
    then
    begin
      writeln(     'PCIADA-C #',pciada_nr,' INTLINE interrupt line   = ',num2hex(INTLINE,2));
      writeln(wdat,'PCIADA-C #',pciada_nr,' INTLINE interrupt line   = ',num2hex(INTLINE,2));
    end
    else
    begin
      writeln('error');
      writeln(wdat,'error');
      goto_halt;
    end;
    data := portw[iobase+$4c];
    data := data and $ffff;
    writeln(     'IOBASE-LCR      intcsr =',num2hex(data,4));
    writeln(wdat,'IOBASE-LCR      intcsr =',num2hex(data,4));

    data := portw[iobase+$50];
    data := data and $ffff;
    writeln(     'IOBASE-LCR      cntrl  =',num2hex(data,4));
    writeln(wdat,'IOBASE-LCR      cntrl  =',num2hex(data,4));

    data := rdx16(MEMBASE_LCR+$4c);
    data := data and $ffff;
    writeln(     'MEMBASE-LCR     intcsr =',num2hex(data,4));
    writeln(wdat,'MEMBASE-LCR     intcsr =',num2hex(data,4));

    data := rdx16(MEMBASE_LCR+$50);
    data := data and $ffff;
    writeln(     'MEMBASE-LCR     cntrl  =',num2hex(data,4));
    writeln(wdat,'MEMBASE-LCR     cntrl  =',num2hex(data,4));
(*++++*)
    (* Check Vebindung  *)
    data := portw[IOBASE + $50] and $0800;
    if data = $0000 then
    begin
      textcolor(4);
      writeln(     'PCIADA-C #',pciada_nr,' not connected');
      writeln(wdat,'PCIADA-C #',pciada_nr,' not connected');
      writeln(     'Check CAMACCRATE-POWER and CABLE !');
      writeln(wdat,'Check CAMACCRATE-POWER and CABLE !');
      textcolor(7);
      goto_halt;
    end;
    (* Check Staturegister *)
    pciada_on;
    textcolor(2);
    write(     'PCIADA-C #', pciada_nr ,' connected with');
    write(wdat,'PCIADA-C #', pciada_nr ,' connected with');
    data := rdx16(CC32BASE+$0); (* Statusregister read *);
    if ((data shr 12) = $0008) or ((data shr 12) = $0001) then
    begin
      if (data shr 12) = $0001 then
      begin
        textcolor(4);
        writeln(     ' VMEMM');
        writeln(wdat,' VMEMM');
        writeln(     'VMEMM-Status = ',num2hex(data,4));
        writeln(wdat,'VMEMM-Status = ',num2hex(data,4));
        textcolor(7);
        goto_halt;
      end;
      if (data shr 12) = $0008 then
      begin
        write(     ' CC32');
        write(wdat,' CC32');
        datax := (data and $00F0) shr 4;
        writeln(     ' ModulNr.:',datax);
        writeln(wdat,' ModulNr.:',datax);
        writeln(     'CC32-Status = ',num2hex(data,4));
        writeln(wdat,'CC32-Status = ',num2hex(data,4));
        textcolor(7);
      end;
    end
    else
    begin
      textcolor(4);
      write(     ' Undefind Modul found');
      write(wdat,' Undefind Modul found');
      writeln(     'Statusregister = ',num2hex(data,4));
      writeln(wdat,'Statusregister = ',num2hex(data,4));
      textcolor(7);
      goto_halt;
    end;
    (* ++++ CC32-Register  *)
    wrx32(CC32BASE+ 26 shl 10,$aaaaaaaa);  (* write broadcat Mask reg *)
    data:= rdx32(CC32BASE+(26 shl 10));    (* read broadcat Mask reg *)
    writeln(wdat,'Broadcast-Mask read = ',num2hex(data,8));
    wrx32(CC32BASE + 1 shl 1 + 2 shl 6,$55555555);(* write N2 *)
    data:= rdx32(CC32BASE + 29 shl 10);   (* read LED*)
    writeln(wdat,'LED-Status = ',num2hex(data,8));
    close (wdat);
    writeln('PCICC32-Chek finish >> CC32 found >> File PCIADA-C.TXT create !');
    writeln('press any key for more tests');
    repeat until keypressed;ch := ReadKey;
  end;
(* ------------------------------------------------------- PCIADA on *)
    procedure pciada_on;
    begin portw[IOBASE + $50] := $4184; end;
(* -------------------------------------------------------- PCIADA off*)
    procedure pciada_off;
    begin portw[IOBASE + $50] := $4084; end;
    (*  !!!!! add disable interrupt and sysfail *)
(* -------------------------------------------------------- PCIADA off*)
    procedure pciada_autoread_on;
    begin portw[IOBASE + $50] := $4182; end;
    (*  !!!!! User0 = 0 autoread on *)
(* -------------------------------------------------------- PCIADA off*)
    procedure pciada_autoread_off;
    begin portw[IOBASE + $50] := $4186; end;
    (*  !!!!! USER0 = 1 autoread off *)
(* -------------------------------------------------------- set pcx_intcsr *)
    procedure pciada_intcsr;
    begin portw[IOBASE + $4c] := $0009; end;
(* -------------------------------------------------------- cle timeoverff *)
   procedure PCIADA_clr_timeovff;
   begin
     PCIADA_off;                          (* time-over-ff clear *)
     PCIADA_on;
   end;

(* -------------------------------------------------------- Init CC32 *)
   Procedure PCIADA_init;
   begin
     PCIADA_off;
     PCIADA_intcsr;                       (* intcsr default *)
     PCIADA_on;
  end;

   procedure writebit(data:word);
   var i : integer;
   begin
     for i := 1 to 16 do
     begin
       if (data and $8000) = $8000 then write(' 1  ') else write(' 0  ');
       data := data shl 1;
     end;
     writeln;
   end;
    (* -----------------------------------------------------  *)
   procedure wr_ispl_stat;
   var data : integer;
   begin
      write('MT3 MT2 MT1 MT0 SV3 SV2 SV1 SV0 NR3 NR2 NR1 NR0  Q   X  INH LAM');
      writeln ('CC32_stat');
      data := rdx16(CC32BASE);
      writebit(data)
   end;
   (* ------------------------------------------------------  *)
   procedure wr_plx_int_reg;
   var data : integer;
   begin
     write(' -   -   -   -   -   -   -   -  SI1 IEN I2S I2P I2E I1S I1P I1E');
     writeln (' plx_int_reg');
     data := portw[IOBASE + $4c];
     writebit(data)
    end;
  (* ------------------------------------------------------ read Vectot *)
   procedure wr_plx_cntrl_reg;
   var data : integer;
   begin
     write(' -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   - ');
     writeln (' plx_cntrl_reg');
     data := portw[IOBASE + $50];
     writebit(data)
    end;
  (* ------------------------------------------------------ read Vectot *)
  Procedure RD_vector;
    var intcsr,vmemm_irqstat : word;
    begin
      vector := $00;
      intcsr := portw[IOBASE + $4c];
      (*  writeln(num2hex(intcsr,2));   *)
      if (intcsr and $0020) = $0020 then (* test int2 *)
      begin
        vector := $01; (* int2 detect > vector to $01 *)
        pciada_off;    (* reset int2 *)
        pciada_on;     (* reset int2 *)
      end
      else
      begin
        if (intcsr and $0004) = $0004 then (* test int1 *)
        begin
          vector := $02; (* int1 detect > vector to $02 *)
       end
      end;
    end;

(*    **cc32**    *)

(* ----------------------------------------------- cc32 reset  *)
Procedure cc32_res;
Begin
    ln:=31; la:=0; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx16(cc32base+lnaf,0); (* lade NAF-register *)
End;
(* --------------------------------------------------------- Camac Clear *)
Procedure cc32_C;
begin
	wrx16(CC32BASE,0);  (* dataway C *)
end;

(* --------------------------------------------------------- Camac Clear *)
Procedure cc32_C_res_I;
begin
	wrx16(CC32BASE+$80,0);  (* dataway C *)
end;
(* -----------------------------------------------------Camac Initialise *)
Procedure cc32_Z;
begin
	wrx16(CC32BASE+$40,0);  (* dataway Z *)
end;
(* -----------------------------------------------------Camac Initialise *)
Procedure cc32_Z_set_I;
begin
	wrx16(CC32BASE+$c0,3);  (* dataway Z *)
end;
(* ------------------------------------------------- Set dataway Inhibit *)
Procedure cc32_set_I;
Begin
    ln:=27; la:=0; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx16(cc32base+lnaf,1); (* lade NAF-register *)
End;
(* ----------------------------------------------- Reset dataway Inhibit *)
Procedure cc32_res_I;
Begin
    ln:=27; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx16(cc32base+lnaf,0); (* lade NAF-register *)
End;
(* ----------------------------------------------- test and set cI *)
Procedure cc32_tst_I;
Begin
  if (rdx16(cc32base+0) and $0002) = 0 then cI := false else cI := true;
END;
(* ----------------------------------------------- test and set cL *)
Procedure cc32_tst_LAMff;
Begin
  if (rdx16(cc32base+0) and $0001) = 0 then cL := false else cL := true;
END;
(* ----------------------------------------------- clr cL *)
Procedure cc32_res_LAMff;
Begin
    ln:=28; la:=0; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx16(cc32base+lnaf,0); (* lade NAF-register *)
End;
(*    ------------------------------------------- Clear Lam Mask registers *)
Procedure cc32_res_lmall;
Begin
    ln:=28; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx32(CC32BASE+lnaf,0);  (* write long adrreg from ispl *)
End;

(* ---------------------------------------------- Set Lam Mask registers *)
Procedure cc32_set_lmall;
Begin
    ln:=28; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx32(CC32BASE+lnaf,$ffffff);  (* write long adrreg from ispl *)
End;

(* -------------------------------------------------- Enable LAM Maskbit *)
Procedure cc32_set_lmbit (n : byte);
Var	mask , maskbit : LongInt;
Begin
    ln:=28; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    mask := rdx32(CC32BASE+lnaf);  (* read long adrreg from ispl *)
    maskbit := 1;
    maskbit := maskbit shl (n-1);
    mask := mask or maskbit;
    wrx32(CC32BASE+lnaf,mask);  (* read long adrreg from ispl *)
End;

(* ------------------------------------------------- Disable LAM Maskbit *)
Procedure cc32_res_lmbit (n : byte);
Var	mask , maskbit : LongInt;
Begin
    ln:=28; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    mask := rdx32(CC32BASE+lnaf);  (* read long adrreg from ispl *)
    maskbit := 1;
    maskbit := maskbit shl (n-1);
    mask := mask and not maskbit;
    wrx32(CC32BASE+lnaf,mask);  (* read long adrreg from ispl *)
End;

(* ----------------------------------------------------------- Read Mask *)
Procedure cc32_rd_LamMask (Var mask : LongInt);
Begin
    ln:=28; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    mask := rdx32(CC32BASE+lnaf);  (* read long adrreg from ispl *)
End;

(* ------------------------------------------------------------ Read LAM *)
Procedure cc32_rd_LamBus (Var lam : LongInt);
Begin
    ln:=28; la:=2; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    lam := rdx32(CC32BASE+lnaf);  (* read long adrreg from ispl *)
End;
(* ------------------------------------------------------------ Read LAM *)
Procedure cc32_rd_LamAnd (Var lam : LongInt);
Begin
    ln:=28; la:=3; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    lam := rdx32(CC32BASE+lnaf);  (* read long adrreg from ispl *)
End;
(* ------------------------------------------------------------ Read LAM *)
Procedure cc32_rd_LamNot (Var lam : LongInt);
Begin
    ln:=28; la:=4; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    lam := rdx32(CC32BASE+lnaf);  (* read long adrreg from ispl *)
End;
(* ------------------------------------------------------------ Read LED *)
Procedure cc32_rd_LED (Var led : LongInt);
Begin
    ln:=29; la:=0; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    led := rdx32(CC32BASE+lnaf);  (* read long adrreg from ispl *)
    if led and $80000000 = 0 then cQ := false else cQ := true;
    if led and $40000000 = 0 then cX := false else cX := true;
    if led and $20000000 = 0 then cI := false else cI := true;
    if led and $10000000 = 0 then cL := false else cL := true;
    if led and $08000000 = 0 then cC := false else cC := true;
    if led and $04000000 = 0 then cZ := false else cZ := true;
    led := led and $00ffffff;
End;
(* ------------------------------------------------------------ Read LAM *)
Procedure cc32_wr_LMask (lmask : LongInt);
Begin
    ln:=28; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx32(CC32BASE+lnaf,lmask);  (* read long adrreg from ispl *)
End;
(* ------------------------------------------------------------ Read LAM *)
Procedure cc32_wr_BMask (bmask : LongInt);
Begin
    ln:=26; la:=1; lf:=0;
    lnaf:= ln shl 10 + la shl 6 + lf shl 2;
    wrx32(CC32BASE+lnaf,bmask);  (* read long adrreg from ispl *)
End;
(* --------------------------------------------------------------------- *)
Procedure cc32_wr16 (n,a,f:integer;data:LongInt);
Var       naf      : word;
	  csr      : word;
Begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    wrx16(cc32base+naf,data); (* lade NAF-register *)
End;

Procedure cc32_wr16qx (n,a,f:integer;data:LongInt);
Var  naf,csr : word;
Begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    wrx32(cc32base+naf,data); (* lade NAF-register *)
    csr := rdx16(cc32base);
    if (csr and $0008) = 0 then cQ := false else cQ := true;
    if (csr and $0004) = 0 then cX := false else cX := true;
End;

Procedure cc32_wr24 (n,a,f : integer;
                    data  : LongInt);
Var       naf,csr      : word;
Begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    wrx32(CC32BASE+naf,data);  (* write long adrreg from ispl *)
End;

Procedure cc32_wr24qx (n,a,f : integer;
                    data  : LongInt);
Var naf,csr : word;
Begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    wrx32(CC32BASE+naf,data);  (* write long adrreg from ispl *)
    csr := rdx16(cc32base);
    if (csr and $0008) = 0 then cQ := false else cQ := true;
    if (csr and $0004) = 0 then cX := false else cX := true;
End;
Procedure cc32_rd16 (n,a,f : integer;
                  var data  : LongInt);
var   naf,wordl            : word;
      csr                  : word;
begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    data := rdx16(cc32base+naf);
End;
Procedure cc32_rd16qx (n,a,f : integer;
                  var data  : LongInt);
var   naf,wordl            : word;
      csr                  : word;
begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    data := rdx32(CC32BASE+naf);  (* read24 *)
    if data and $80000000 = 0 then cQ := false else cQ := true;
    if data and $40000000 = 0 then cX := false else cX := true;
    data := data and $0000ffff;
End;

Procedure cc32_rd24 (n,a,f : integer;
                  var data  : LongInt);
var   naf,wordh,wordl      : word;
      csr                  : word;
begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    data := rdx32(CC32BASE+naf);  (* read long adrreg from ispl *)
    data := data and $00ffffff;
End;
Procedure cc32_rd24qx (n,a,f : integer;
                  var data  : LongInt);
var   naf,wordl            : word;
      csr                  : word;
begin
    naf:= n shl 10 + a shl 6 + f shl 2;
    data := rdx32(CC32BASE+naf);  (* read24 *)
    if data and $80000000 = 0 then cQ := false else cQ := true;
    if data and $40000000 = 0 then cX := false else cX := true;
    data := data and $00ffffff;
End;


    {--- Interrupt-Handler -----------------------------------------------}
    procedure PCIADA0service  ; interrupt;
    begin
      portw[IOBASE + $4c] := $0009;  		(* disable PCIATA interrupt by PLX_Chip *)
      if intcontr2 then port[$a0]:=$20;
      port[$20]:=$20; 				(* Interrupt-Controller resetten *)
      inc(intcount);
  {   writeln('*',intcount);   }	        (* use by test only  *)
      PCIADA_off;
      PCIADA_on;
      portw[IOBASE + $4c] := $0049;  		(* enable PCIATA interrupt by PLX_Chip *)
    end;

    procedure clearstatus;
    begin
      if intcontr2
      then port[$a0]:=$20;
      port[$20]:=$20;
    end;

    function IntNr:byte;
    begin
      if intline <8 then IntNr:=intline + 8
      else IntNr := intline + $68;
    end;

    procedure PCIADA_enable_irq;
    var p : pointer;
        i : byte;
    begin
      if (intline = 0) or (intline > 15) then
      begin
        writeln('Intline ',intline,'not supported!');
        writeln(chr($07));
        write('press any key to exit:');
        repeat until keypressed;ch := ReadKey;
        exit;
      end;
      if active then
      begin
        writeln('PCIADA-C is aktivated!');
        writeln(chr($07));
        write('press any key to exit:');
        repeat until keypressed;ch := ReadKey;
        exit;
      end;
      active:=true;
      intcount := 0;
      intmask := (1 shl (intline and 7));
      intcontr2 := (intline>7);                (* 2. Interrupt-Controller  *)
      getintvec(IntNr,oldvector);              (* save old vector *)
      setintvec(IntNr,@PCIADA0service);
      if intcontr2
      then port[$a1]:=port[$a1] and (not intmask)  (* enable interrupt by controller *)
      else port[$21]:=port[$21] and (not intmask);
      clearstatus;
      portw[IOBASE + $4c] := $0049;                (* enable PCIATA interrupt by PLX_Chip *)
    end;

    procedure PCIADA_disable_irq;
    begin
      if active then
      begin
        active:=false;
        portw[IOBASE + $4c] := $0009; 	           (* disable PCIATA interrupt by PLX_Chip *)
        if intcontr2
        then port[$a1]:=port[$a1] or intmask       (* disable interrup by controller *)
        else port[$21]:=port[$21] or intmask;
        setintvec(IntNr,oldvector);
        clearstatus;
      end;
    end;
    { Exit-Prozedur }

    {$F+}
    procedure comexit;
    var i : byte;
    begin
    i := 0;
          PCIADA_disable_irq;
      exitproc:=exitsave;
    end;
    {$F-}

    begin
      exitsave:=exitproc;
      exitproc:=@comexit;
    end.
