	IDEAL
	MODEL TPASCAL

	GLOBAL PASCAL InitUnreal:FAR
	GLOBAL PASCAL IsV86:FAR
	GLOBAL PASCAL Is386:FAR

	GLOBAL PASCAL Ptr2Lin:FAR

	GLOBAL PASCAL wrx8:FAR
	GLOBAL PASCAL wrx16:FAR
	GLOBAL PASCAL wrx32:FAR

	GLOBAL PASCAL rdx8:FAR
	GLOBAL PASCAL rdx16:FAR
	GLOBAL PASCAL rdx32:FAR

	GLOBAL PASCAL MoveX:FAR
	GLOBAL PASCAL FillCharX:FAR


; ---------------------------------------------------------------------------

	; define selector to use (ES,FS,GS)
	SELECTOR EQU fs

	; enable this flag if selector is always zero (boolean)
	ASSUME_SEL_ZERO = 1

; ---------------------------------------------------------------------------

MACRO ZERO_SEL
    IFE ASSUME_SEL_ZERO
	mov ax, 0
;	xor ax, ax
	mov SELECTOR, ax
    ENDIF
ENDM

; ---------------------------------------------------------------------------

MACRO loopx Offs      ; Macro to use ecx in loop instruction
	db 67h
	loop Offs
ENDM

MACRO loopxnz Offs    ; Macro to use ecx in loopnz instruction
	db 67h
	loopnz Offs
ENDM

MACRO loopxne Offs    ; Same as above but just for different syntax
	db 67h
	loopne Offs
ENDM

MACRO loopxz Offs     ; Macro to use ecx in loopz instruction
	db 67h
	loopz Offs
ENDM

MACRO loopxe Offs     ; Same as above but just for different syntax
	db 67h
	loope Offs
ENDM

; ---------------------------------------------------------------------------

	CODESEG
	ASSUME CS:@Code
	P386N

; ---------------------------------------------------------------------------

;function Ptr2Lin( ptr: Pointer ) : LongInt
PROC Ptr2Lin FAR addr_seg:WORD, addr_offs:WORD
	movzx eax, [addr_seg]
	movzx edx, [addr_offs]
	shl eax, 4
	add eax, edx
	mov edx, eax
	shr edx, 16
	ret
ENDP Ptr2Lin

; ---------------------------------------------------------------------------

;procedure MoveX( source, dest, count: LongInt )
PROC MoveX FAR USES ds, source:DWORD, dest:DWORD, count:DWORD
  	xor ax, ax
	mov esi, [source]
	mov edi, [dest]
	mov es, ax
	mov ds, ax
	mov ecx, [count]
	cld
	rep movs [dword ptr es:edi], [dword ptr ds:esi]
	ret
ENDP MoveX

; ---------------------------------------------------------------------------

;procedure FillCharX( addr: LongInt; count: LongInt; value: Word );
PROC FillCharX FAR, addr:DWORD, count:DWORD, value:WORD
  	xor ax, ax
	mov edi, [addr]
	mov es, ax
	mov ecx, [count]
	mov ax, [value]
	cld
	rep stos [byte ptr es:edi]
        ret
ENDP FillCharX

; ---------------------------------------------------------------------------

;procedure wrx8(Address: LongInt; Value:Byte );
PROC wrx8 FAR Address:DWORD, Value:BYTE
	ZERO_SEL
	mov ebx, [Address]	; 32bit offset
	mov al, [Value]
	mov [SELECTOR:ebx], al
	ret
ENDP wrx8

; ---------------------------------------------------------------------------

;procedure wrx16(Address: LongInt; Value:Word );
PROC wrx16 FAR Address:DWORD, Value:WORD
	ZERO_SEL
	mov ebx, [Address]	; 32bit offset
	mov ax, [Value]
	mov [SELECTOR:ebx], ax
	ret
ENDP wrx16

; ---------------------------------------------------------------------------

;procedure wrx32(Address: LongInt; Value:LongInt );
PROC wrx32 FAR Address:DWORD, Value:DWORD
	ZERO_SEL
	mov ebx, [Address]	; 32bit offset
	mov eax, [Value]
	mov [SELECTOR:ebx], eax
	ret
ENDP wrx32

; ---------------------------------------------------------------------------

;function rdx8(Address: LongInt): Byte;
PROC rdx8 FAR Address:DWORD
	ZERO_SEL
	mov ebx, [Address]	; 32bit offset
	mov al, [SELECTOR:ebx]
	ret
ENDP rdx8

; ---------------------------------------------------------------------------

;function rdx16(Address: LongInt): Word;
PROC rdx16 FAR Address:DWORD
	ZERO_SEL
	mov ebx, [Address]	; 32bit offset
	mov ax, [SELECTOR:ebx]
	ret
ENDP rdx16

; ---------------------------------------------------------------------------

;function rsx32(Address: LongInt): LongInt;
PROC rdx32 FAR Address:DWORD
	ZERO_SEL
	mov ebx, [Address]	; 32bit offset
	mov eax, [SELECTOR:ebx]
        mov edx, eax
	shr edx, 16
	ret
ENDP rdx32

; ---------------------------------------------------------------------------

PROC Is386 FAR
	; check for 386+
        pushf
        pushf
        pop cx
        xor ch, 40h
        push cx
        popf
        pushf
        pop bx
        popf
	xor ax, ax
        cmp ch, bh
        jne short ptr @@no386
	inc ax
@@no386:
	ret
ENDP Is386

; ---------------------------------------------------------------------------

PROC IsV86 FAR
	; check for virtual mode
	P386
	smsw ax
	P386N
	and al, 1
	ret
ENDP IsV86 

; ---------------------------------------------------------------------------

; descriptor table entry struct
STRUC segment_descr
	length_00_15		dw ?
	base_00_15		dw ?
	base_16_23		db ?
	flags1			db ?
	flags2_length_16_19	db ?
	base_24_31		db ?
ENDS segment_descr 

; ---------------------------------------------------------------------------

PROC InitUnreal Far
	; save data segment
	push ds

	; set segment registers
	ASSUME cs:@Code, ds:@Code
	mov bx, cs
	mov ds, bx

  	; save segment registers
	; cs still in bx
    	mov [rm_code], bx
    	mov ax, ss
    	mov [rm_stack], ax

    	; prepare gdt
	; cs still in bx
        P386N
    	movzx eax, bx
    	shl eax, 4
    	mov [code16.base_00_15], ax
    	mov [data16.base_00_15], ax
    	shr eax, 8
    	mov [code16.base_16_23], ah
    	mov [data16.base_16_23], ah

    	; prepare gdt_ptr
	; cs still in bx
    	movzx eax, bx
    	shl eax, 4
	xor ebx, ebx
	mov bx, Offset Dummy
	add eax, ebx
    	mov [dword gdt_start+2], eax

    	P386
	; disable interrupts
    	cli

    	; load global descriptor table
    	lgdt [GDT]

    	; switch to protected mode
    	mov eax, cr0
    	or  al, 1
    	mov cr0, eax

	; jmp far - without optimization by TASM
	; clear instruction queue
	db 0eah
	dw offset Start_PM, code16_idx

    	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    	; CPU now in protected mode!
Start_PM:
    	ASSUME ds:NOTHING, fs:NOTHING, gs:NOTHING, es:NOTHING

        ; load all segment registers/selectors once
    	mov ax, data16_idx
    	mov ds, ax
    	mov es, ax
    	mov fs, ax
    	mov gs, ax
;    	mov ax, stack16_idx
;    	mov ss, ax ; this is senseless since we don't use esp/ebp in real mode

    	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    	; switch back to real mode
    	mov eax, cr0
    	and al, 0feh
    	mov cr0, eax

    	P386N
    	; jmp far - no optimization by TASM
    	db 0eah
    	dw Offset Stop_PM
rm_code dw 0
Stop_PM:

    	; restore data segment
    	ASSUME ds:@Code
    	mov ax, cs
    	mov ds, ax

    	; restore stack segment
    	mov ax, [rm_stack]
    	mov ss, ax

	; interrupts are now save again
    	sti

	; prepare fs, gs
	xor ax, ax
	mov fs, ax
	mov gs, ax

        ; restore data segment
        pop ds
	ASSUME ds:NOTHING

	ret
ENDP InitUnreal

	; save real mode stack segment
	rm_stack dw ?

	; global descriptor table for protected mode
	label GDT fword
	gdt_start dw            gdt_size, 0, 0
	dummy     segment_descr <0,0,0,0,0>
	code16    segment_descr <0ffffh,0,0,9eh,8fh,0>
	data16    segment_descr <0ffffh,0,0,92h,8fh,0>
	stack16   segment_descr <0ffffh,0,0,92h,8fh,0>
	gdt_size   = $ - (Offset dummy)

	code16_idx = (Offset code16) - (Offset dummy)
	data16_idx = (Offset data16) - (Offset dummy)
	stack16_idx= (Offset stack16)- (Offset dummy)


	END
