UNIT _unreal;
INTERFACE

procedure wrx8( Address: LongInt; Value: Byte    );
procedure wrx16( Address: LongInt; Value: Word    );
procedure wrx32( Address: LongInt; Value: LongInt );

function rdx8(  Address:  LongInt ): Byte;
function rdx16( Address:  LongInt ): Word;
function rdx32( Address:  LongInt ): LongInt;

procedure FillCharX( addr: LongInt; count: LongInt; value: Word );
procedure MoveX( source, dest, count: LongInt );

Function Ptr2Lin( ptr: Pointer ): LongInt;


IMPLEMENTATION
USES _TPXMS;

{$F+}
{$L _unreal}

procedure InitUnreal; far; external {unreal};
function IsV86: Boolean; far; external {unreal};
function Is386: Boolean; far; external {unreal};

Function Ptr2Lin( ptr: Pointer ): LongInt; external {unreal};

procedure wrx8(  Address: LongInt; Value: Byte    ); external {unreal};
procedure wrx16( Address: LongInt; Value: Word    ); external {unreal};
procedure wrx32( Address: LongInt; Value: LongInt ); external {unreal};

function rdx8(  Address: LongInt ): Byte; external {unreal};
function rdx16( Address: LongInt ): Word; external {unreal};
function rdx32( Address: LongInt ): LongInt; external {unreal};

procedure FillCharX( addr: LongInt; count: LongInt; value: Word );
external {unreal};
procedure MoveX( source, dest, count: LongInt ); external {unreal};

BEGIN

  (* check for 386+ *)
  if not Is386 then begin
    WriteLn('Error: CPU is not a 80386 or higher');
    Halt(1);
  end;

  (* check for V86 mode *)
  if isV86 then begin
    WriteLn('Error: CPU is in V86 mode, cannot switch to protected mode');
    Writeln('Boot your PC with the DOS-BOOT-DISK for PCIADA-configuration');
    Halt(2);
  end;

  (* enable 'extended' real mode *)
  InitUnreal;

  (* enable A20 via XMS manager *)
  if not isXMS then begin
    WriteLn('Error: No XMS manager loaded (HIMEM.SYS or similar)');
    Writeln('Boot your PC with the DOS-BOOT-DISK for PCIADA-configuration');
    (* TODO: enable A20 via BIOS 15h *)
    Halt(3);
  end
  else begin
    (* enable A20 *)
    if not A20IsEnabled then
      A20GlobalEnable;
    if not A20IsEnabled then begin
      WriteLn('Error: Could not enable A20!' );
      Halt(4);
    end
  end

END.
