;;------------------------------------------------------------------------
;; PCIC32A.asm - assembler part of the pcicc32 CAMAC driver of ARW Elektronik
;;
;; (c) 2000 ARW Elektronik
;;
;; this source code is published under GPL (Open Source). You can use, redistrubute and 
;; modify it unless this header   is not modified or deleted. No warranty is given that 
;; this software will work like expected.
;; This product is not authorized for use as critical component in life support systems
;; wihout the express written approval of ARW Elektronik Germany.
;;
;; Please announce changes and hints to ARW Elektronik
;;
;; what                                                  who     when
;; first parts, derived from pcivmea.asm                 AR      03.03.2000
;;
name PCIC32A
.386p
;; ------------------------------------------------
;; ------------------------------------------------
;; PCIC32A.asm -- Assembly module, MAIN module for
;; Dynamically loadable VxD for PCICC32 board pair
;; ------------------------------------------------
;; ------------------------------------------------

;; -----------------------------------
;; INCLUDE files needed by this module
;; -----------------------------------

include <vmm.inc>
include <vwin32.inc>
include <debug.inc>

;; ------------------------------------
;; C routines/data used by this module
;; ------------------------------------

;; ==============================================================================
VPCIC32D_MajoREV  equ 1       ;PCIC32's MAJOR revision level
VPCIC32D_MinoREV  equ 1	      ;decimal number of revision
VPCIC32D_DeviceID equ Undefined_Device_ID ;no need for MS device number assignment
;;===============================================================================

;; ---------------------------------------------
;; Virtual Device Declaration (Required)
;; (Declares this code as virtual device driver)
;; Also creates the Device Data Block
;; ---------------------------------------------
 
Declare_Virtual_Device VPCIC32D,\
                       VPCIC32D_MajoREV,\
                       VPCIC32D_MinoREV,\
                       VPCIC32D_Control,\
                       VPCIC32D_DeviceID,\
                       Undefined_Init_Order


VxD_LOCKED_CODE_SEG
;; --------------------------------------------
;; Control Dispatch Table & Proc
;; Used to dispatch supported messages sent by
;; VMM -- clears carry for unsupported mssgs.
;; --------------------------------------------

BeginProc VPCIC32D_Control
    Control_Dispatch Sys_Dynamic_Device_Init, CVPCIC32D_Device_Init,   sCall 
    Control_Dispatch Sys_Dynamic_Device_Exit, CVPCIC32D_Device_UNInit, sCall 
    Control_Dispatch W32_DeviceIoControl,     CVPCIC32D_Device_IOctrl, sCall, <ecx, esi>
    clc
	ret
EndProc VPCIC32D_Control

;; ======================================================
;; Routines below are miscellaneous assembly interfaces
;; ======================================================

;---------------------
; inpd, outpd
;---------------------
BeginProc ___inpd,PUBLIC
          mov     dx,word ptr [esp+4]
          in      eax,dx
          ret
EndProc   ___inpd

BeginProc ___outpd,PUBLIC
          mov     dx,word ptr [esp+4]
          mov     eax,dword ptr [esp+8]
          out     dx,eax
          ret
EndProc   ___outpd


VxD_LOCKED_CODE_ENDS

        END


;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------

