#ifndef __VPCIC32D_H__
#define __VPCIC32D_H__
//-------------------------------------------------------------------------
// WIN95 driver for PCICC32 CAMAC interface from ARW Elektronik, Germany --
//
// vpcic32d.h - the general header file to share information between driver
// and application
//
// (c) 2000 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// without the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what                                            who          when
// first steps                                     AR           07.03.2000
//


// the action codes for ioctl calls
#define VPCIC32_ATTACH_CC32        0x00220000  // METHOD_BUFFERED + FILE_ANY_ACCESS +
#define VPCIC32_DETACH_CC32        0x00220004  // FILE_DEVICE_UNKNOWN
#define VPCIC32_GET_STATUS         0x00220008
#define VPCIC32_CLEAR_STATUS       0x0022000C

// this structure is input in all ioctl calls
typedef struct
{
	DWORD dwInterface;          // CC32 module number
} VPCIC32D_DEVICE;

// this structure is output from VPCIC32_ATTACH_CC32 call
typedef struct
{
	DWORD dwInterface;          // CC32 module number
	void  *pvWindowBase;        // the base address into the 32 kbyte Window of CC32
} VPCIC32D_WINDOW;

// this structure is output from VPCIC32_GET_STATUS call
typedef struct
{
	DWORD dwInterface;          // CC32 module number
	WORD  bTimeout;             // denotes PCIADA timeout
	WORD  bInterrupt;           // denotes a pending LAM interrupt
} VPCIC32D_STATUS;    

#endif // __VPCIC32D_H__