#ifndef __OS_WRAPPER_H__
#define __OS_WRAPPER_H__

//-------------------------------------------------------------------------------------------
// os_wrapper.h - defaults and interface functions of pcilib.c common for NT + 95
// (c) 1999-2002 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
//
// $Log: os_wrapper.h,v $
// Revision 1.2  2002/10/27 17:32:17  klaus
// CVS log added, WINNT 2 Gbyte file size circumvent
//
// what                                                              who    when
// written for use with PCIVME interface                             AR     22.03.1999
// derived from pcilib.h                                             AR     11.11.1999      
//

 //-----------------------------------------------------------------------------
 // PROTOTYPES
 //
 void PrepareForOS(void);                             /* do OS specific things */

 int   Init_Interface(int InterfaceNumber);           /* Inits to DefAModifier */
 void  DeInit_Interface(int InterfaceNumber);         /* de-initializes Interface */
 void  Reset_VME(void);                               /* generates SYSRESET on VMEbus */

 int   GetError(void);                                /* checks the ERROR flag */
 void  ClearError(void);                              /* clears the ERROR flag */

 char  ReadByte(unsigned long,unsigned short);        /* Get byte from any address */
 void  WriteByte(unsigned long,char,unsigned short);  /* write byte to any address */
 short ReadWord(unsigned long,unsigned short);        /* get word from any address */
 void  WriteWord(unsigned long, short,unsigned short);/* write word to any address */
 long  ReadLong(unsigned long,unsigned short);        /* read longword from any address */
 void  WriteLong(unsigned long,long,unsigned short);  /* write longword to any address */

 char  ReadVectorByte(void);            /* reads a vector byte from VME_LEVEL */
 short ReadVectorWord(void);            /* reads a vector word from VME_LEVEL */
 long  ReadVectorLong(void);            /* reads a vector longword from ..    */

 char  TAS(unsigned long,unsigned short);      /* 68K TAS (semfore) emulation */
 void  SetSfail(void);                                         /* set SYSFAIL */
 void  ClrSfail(void);                                 /* clear SYSFAIL (own) */
 unsigned short PollSfail(void);                        /* get SYSFAIL status */

 void GetInterfaceInfo(char type);    /* request some information from driver */
 void _SetModifier(unsigned short modifier);

                                      /* set and get register contents of ..  */
 unsigned long _SetRegister(unsigned long Address, unsigned long Value);
 unsigned long _GetRegister(unsigned long Address);

 //-----------------------------------------------------------------------------
 // EXTERNALS
 //
 extern char *cszDriverPath;                                 /* path of driver */
 extern int  nInterfaceNumber;                       /* interface number 0..15 */
 extern int  WordMode;                           /* mode of VME path operation */

 /*-------------------------- End of Prototypes -------------------------------*/

#endif /* __OS_WRAPPER_H__ */

//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
