#ifndef __PCILIB95_H__
#define __PCILIB95_H__

//-------------------------------------------------------------------------------------------
// pcilib.h - defaults and interface functions of pcilib.c
// (c) 1999-2002 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
//
// $Log: pcilib95.h,v $
// Revision 1.2  2002/10/27 17:32:17  klaus
// CVS log added, WINNT 2 Gbyte file size circumvent
//
// what                                                              who    when
// written for use with PCIVME interface                             AR     22.03.1999
// modified to use together with WIN-NT                              AR     11.11.1999
//

 //-----------------------------------------------------------------------------
 // PROTOTYPES
 //
 int   Init_Interface95(int InterfaceNumber);           /* Inits to DefAModifier */
 void  DeInit_Interface95(int InterfaceNumber);         /* de-initializes Interface */
 void  Reset_VME95(void);                               /* generates SYSRESET on VMEbus */

 int   GetError95(void);                                /* checks the ERROR flag */
 void  ClearError95(void);                              /* clears the ERROR flag */

 char  ReadByte95(unsigned long,unsigned short);        /* Get byte from any address */
 void  WriteByte95(unsigned long,char,unsigned short);  /* write byte to any address */
 short ReadWord95(unsigned long,unsigned short);        /* get word from any address */
 void  WriteWord95(unsigned long, short,unsigned short);/* write word to any address */
 long  ReadLong95(unsigned long,unsigned short);        /* read longword from any address */
 void  WriteLong95(unsigned long,long,unsigned short);  /* write longword to any address */

 char  ReadVectorByte95(void);            /* reads a vector byte from VME_LEVEL */
 short ReadVectorWord95(void);            /* reads a vector word from VME_LEVEL */
 long  ReadVectorLong95(void);            /* reads a vector longword from ..    */

 char  TAS95(unsigned long,unsigned short);      /* 68K TAS (semfore) emulation */
 void  SetSfail95(void);                                         /* set SYSFAIL */
 void  ClrSfail95(void);                                 /* clear SYSFAIL (own) */
 unsigned short PollSfail95(void);                        /* get SYSFAIL status */

 void GetInterfaceInfo95(char type);    /* request some information from driver */
 void _SetModifier95(unsigned short modifier);

                                      /* set and get register contents of ..  */
 unsigned long _SetRegister95(unsigned long Address, unsigned long Value);
 unsigned long _GetRegister95(unsigned long Address);

 //-----------------------------------------------------------------------------
 // EXTERNALS
 //
 extern char cszDriverPath95[];                              /* path of driver */
 extern int  nInterfaceNumber;                       /* interface number 0..15 */
 extern int  WordMode;                           /* mode of VME path operation */
 
 /*-------------------------- End of Prototypes -------------------------------*/

#endif /* __PCILIB95_H__ */

//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
