#ifndef __PCILIBNT_H__
#define __PCILIBNT_H__

//-------------------------------------------------------------------------------------------
// pcilib.h - defaults and interface functions of pcilib.c for WIN-NT
// (c) 1999-2002 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
//
// $Log: pcilibNT.h,v $
// Revision 1.2  2002/10/27 17:32:17  klaus
// CVS log added, WINNT 2 Gbyte file size circumvent
//
// what                                                              who    when
// written for use with PCIVME interface                             AR     22.03.1999
// modified to use together with WIN95                               AR     11.11.1999      
//

 //-----------------------------------------------------------------------------
 // PROTOTYPES
 //
 int   Init_InterfaceNT(int InterfaceNumber);           /* Inits to DefAModifier */
 void  DeInit_InterfaceNT(int InterfaceNumber);         /* de-initializes Interface */
 void  Reset_VMENT(void);                               /* generates SYSRESET on VMEbus */

 int   GetErrorNT(void);                                /* checks the ERROR flag */
 void  ClearErrorNT(void);                              /* clears the ERROR flag */

 char  ReadByteNT(unsigned long,unsigned short);        /* Get byte from any address */
 void  WriteByteNT(unsigned long,char,unsigned short);  /* write byte to any address */
 short ReadWordNT(unsigned long,unsigned short);        /* get word from any address */
 void  WriteWordNT(unsigned long, short,unsigned short);/* write word to any address */
 long  ReadLongNT(unsigned long,unsigned short);        /* read longword from any address */
 void  WriteLongNT(unsigned long,long,unsigned short);  /* write longword to any address */

 char  ReadVectorByteNT(void);            /* reads a vector byte from VME_LEVEL */
 short ReadVectorWordNT(void);            /* reads a vector word from VME_LEVEL */
 long  ReadVectorLongNT(void);            /* reads a vector longword from ..    */

 char  TASNT(unsigned long,unsigned short);      /* 68K TAS (semfore) emulation */
 void  SetSfailNT(void);                                         /* set SYSFAIL */
 void  ClrSfailNT(void);                                 /* clear SYSFAIL (own) */
 unsigned short PollSfailNT(void);                        /* get SYSFAIL status */

 void GetInterfaceInfoNT(char type);    /* request some information from driver */
 void _SetModifierNT(unsigned short modifier);

                                      /* set and get register contents of ..  */
 unsigned long _SetRegisterNT(unsigned long Address, unsigned long Value);
 unsigned long _GetRegisterNT(unsigned long Address);

 //-----------------------------------------------------------------------------
 // EXTERNALS
 //
 extern char cszDriverPathNT[];                              /* path of driver */
 extern int  nInterfaceNumber;                       /* interface number 0..15 */
 extern int  WordMode;                           /* mode of VME path operation */

 /*-------------------------- End of Prototypes -------------------------------*/

#endif /* __PCILIBNT_H__ */

//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------
