//-------------------------------------------------------------------------
//
// a universal menuing functions - interpretation of strings and commands
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     22.11.97
//
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <tastatur.h>
#include <interpr.h>

#define MAXSTRINGS 8        // maximale anzahl teilstrings
#define MAXLEN     255      // maximale anzahl zeichen

//------------------------------------------------------------------
// Macht alle Zeichen eines Strings lower
//
static void tolower_string(char *strn)
{
  while (*strn)
  {
    *strn = tolower(*strn);
    strn++;
  }
}

//------------------------------------------------------------------
// Zerlegt einen string aus mehreren tokens in Einzelteile
//
static int split_zeile(char *zeile, char *output[])
{
  int i = 0;
  int len = MAXLEN;

  while (*zeile)
  {
    output[i] = zeile;
    while ((*zeile != BLANK) && (--len) && (*zeile != TAB) && (*zeile != 0))
      zeile++;

    if (++i >= (MAXSTRINGS - 1))
    {
      *zeile = 0;
      break;
    }

    if (*zeile == 0)
      break;

    *zeile = 0;  // zwangsweise terminieren

    if (!len)
      break;

    zeile++;

    while (((*zeile == BLANK) || (*zeile == TAB)) &&
					    ((*zeile != 0) && (--len)))
      zeile++;

    if (*zeile == 0)
      break;

    if (!len)
      break;
  }

  output[i] = NULL;

  return i;
}

//-----------------------------------------------------------------------
// Interpretiert eine Kommandozeile und arbeitet sie ab
// retourniert FALSE bei Fehler in der Interpretierung oder in der
// Abarbeitung
//
int in_interpret_input(char *input, IN_INTERPRET interpret[])
{
  char *buf[MAXSTRINGS];
  IN_INTERPRET *in;
  int k;

  tolower_string(input);

  k = split_zeile(input, buf);

  in = interpret;

  while ((k > 0) && (in->in_text != NULL))
  {
    if (strcmp(in->in_text, buf[0]) == 0)   // teste auf kommando
    {
      if (in->in_aktion != NULL)
	return (in->in_aktion(k, buf));     // fuehre aus
    }
    in++;
  }

  return 0;
}
