#ifndef __MENU_H__
//-------------------------------------------------------------------------
//
// part of generalized menu functions. menu functions itself
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     10.10.98
//
#include <interpr.h>

typedef struct
{
  char wahl_zeichen;           // das auswahl_zeichen
  char *wahl_string;           // der auswahl_string
  void (*print)(void);         // das wird ans ende ausgedruckt
  int  (*aktion)(void);        // aktion bei auswahl, TRUE = abbruch
} MN_MENU_ENTRY;

typedef struct
{
  char wahl_zeichen; // der auswahl-character
  char *wahl_string; // der auswahltext
  void *ergebnis;    // der zeiger auf das zugehoerige ergebnis (w.a.i.d.s.m.)
} MN_WAHL_ENTRY;

typedef struct
{
  char *show_text;
  void (*show_print)(void);
} MN_SHOW_ENTRY;

extern void mn_menu(char *menu_header,
			  int (*entry)(void), MN_MENU_ENTRY menues[]);

extern int mn_abfrage_bool(char *frage_header, char *frage,
			 char true_wert, char false_wert, int *ergebnis);

extern int mn_abfrage_input_element(char *frage_header, char *frage,
			 char *format, void *buffer);

extern int mn_abfrage_input_inplace(char *format, void *buffer);

extern int mn_abfrage_input_text_inplace(void *buffer);

extern int mn_abfrage_multiple(char *header_zeile,
			     MN_WAHL_ENTRY alternative[], int *ergebnis);

extern void mn_show_status(char *header, int (*entry)(void),
				       MN_SHOW_ENTRY status[], int pause);

extern void mn_kommandozeile(char *header,
			 int (*entry)(void), IN_INTERPRET interpret[]);

extern void set_status_zeile(char *zeile);

#define __MENU_H__
#endif