//-------------------------------------------------------------------------
//
// a universal menuing functions - a simple test programm for menus
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     1.11.97
//
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <screen.h>
#include <tastatur.h>
#include <interpr.h>
#include <menu.h>

unsigned long zahl = 0;
char strn[50];

int dummy(void)
{
  return 0;
}

int aktion_a(void)
{
  unsigned long alt_zahl = zahl;

  if (mn_abfrage_input_element(NULL,"Bitte geben Sie eine Zahl ein:","%ld",(void *)&zahl) == 0)
    zahl = alt_zahl;

  return 0;
}

int aktion_b(void)
{
  char buffer[50];

  if (mn_abfrage_input_element("String?","Dies ist die Frage nach dem String","%s",(void *)buffer))
    strcpy(strn,buffer);

  return 0;
}

void print_b(void)
{
  printf("%s",strn);
}

void print_c(void)
{
  printf("%s",strn);
}

int aktion_c(void)
{
  char buffer[100];

  if (mn_abfrage_input_inplace("%s", buffer))
    strcpy(strn, buffer);

  return 0;
}

void print_a(void)
{
  printf("%ld",zahl);
}

int aktion_q(void)
{
  int ergebnis;

  if (mn_abfrage_bool("Verlassenabfrage?","Wirklich verlassen?",
					     'j','n', &ergebnis) == 0)
    return 0;
  else
    return ergebnis;
}

void print_status(void)
{
  static int i;

  printf("%d", i++);
}

int aktion_cmd(int argc, char *argv[])
{
  int i = 0;

  printf("\n\n");

  while (i < (argc - 1))
  {
    printf("%2d - %s\n", i, argv[i]);
    i++;
  }

  printf("\nBitte Taste!\n");
  ts_getch();
  return 1;
}

int aktion_help(int argc, char *argv[])
{
  printf("Es gibt die Kommandos:\n");
  printf("  cmd 1 2 3 4 5\n");
  printf("  hallo\n");
  printf("  help oder ?\n");
  printf("\nBitte Taste!\n");
  ts_getch();
  return 1;
}

int aktion_hallo(int argc, char *argv[])
{
  static int num = 0;

  num += argc;

  printf("Hallo, du da (%d)!\n", num);

  printf("\nBitte Taste!\n");
  ts_getch();
  return 1;
}

int aktion_d(void)
{
  int ergebnis;

  MN_WAHL_ENTRY wahl[] = {{'1', "Hier gehts zur Kommamdozeileneingabe!"},
			  {'2', "Programm beenden (Durchfall)!"},
			  {'3', "Hier geschieht rein garnichts!"},
			  {0, "Ende"}};

  IN_INTERPRET in_in[] = {{"cmd", aktion_cmd},
			  {"hallo", aktion_hallo},
			  {"help", aktion_help},
			  {"?", aktion_help},
			  {NULL, NULL}};

  if (mn_abfrage_multiple("Eine Auswahl:", wahl, &ergebnis) == 0)
    return 0;

  switch (ergebnis)
  {
    case '1': mn_kommandozeile("Gib ein Kommando ein!", dummy, in_in);
	      return 0;
	      
    case '2': return 1;

    case '3': break;
  }

  return 0;
}

void print_sys(void)
{
  static int *i = MK_FP(0,0);
  unsigned int seg, off;

  seg = FP_SEG(i);
  off = FP_OFF(i);

  printf("0x%04x:0x%04x - 0x%04x", seg, off, peek(seg, off));

  i++;
}

int aktion_e(void)
{
  MN_SHOW_ENTRY status[] = {{"Das hier:", print_status},
			   {"Jenes hier:", print_sys},
			   {"Dies hier:", print_sys},
			   {NULL, NULL}};

  mn_show_status("Status", dummy, status, 300);

  return 0;
}

int aktion_nix(void)
{
  return 1;   // ich will aus dem menu heraus, deshalb 1!
}

int aktion_f(void)
{
  MN_MENU_ENTRY menu_2[] = {{-1, "Anzeige des vorigen Status:", print_status, NULL},
			    {'a',"Abfrage einer Zahl:", print_a, aktion_a},
			    {'z',"Weiter bin ich zu faul:", NULL, aktion_e},
			    {'q',"Verlassen", NULL, aktion_nix},
			    {0  , NULL, NULL, NULL}};

  mn_menu("Zweites Menu", dummy, menu_2);

  return 0;   // damit es nicht durchfaellt!
}

int main(void)
{
  MN_MENU_ENTRY menu_1[] = {{-1, "Das ist ein Status:",print_status, NULL},
			    {'a',"Abfrage einer Zahl",print_a,aktion_a},
			    {'b',"Abfrage eines Strings",print_b, aktion_b},
			    {'c',"Direkte Eingabe vor Ort",print_c, aktion_c},
			    {'d',"Ein Auswahlfeld",NULL, aktion_d},
			    {'e',"Zyklische Statusanzeige",NULL, aktion_e},
			    {'f',"Noch ein Menu", NULL, aktion_f},
			    {'q',"Verlassen",NULL, aktion_q},
			    {0,NULL,NULL,NULL}};

  sc_init();
  ts_init();

  mn_menu("Erstes Menu", dummy, menu_1);

  ts_deinit();
  sc_deinit();

  return 0;
}