;-------------------------------------------------------------------------
;
; pcibios support functions - 'long' access function
; (c) 1999 ARW Elektronik
;
; this source code is published under GPL (Open Source). You can use, redistrubute and
; modify it unless this header  is  not modified or deleted. No warranty is given that
; this software will work like expected.
; This product is not authorized for use as critical component in life support systems
; wihout the express written approval of ARW Elektronik Germany.
;
; Please announce changes and hints to ARW Elektronik
;
; what							who    when
; first steps						AR     01.11.1997
;

LREGS      STRUC
_EAX       DD  ?
_EBX       DD  ?
_ECX       DD  ?
_EDX       DD  ?
_ESI       DD  ?
_EDI       DD  ?
_cflag     DW  ?
_flag      DW  ?
LREGS      ENDS

	   DOSSEG
	   .MODEL compact
	   .Code
	   .386P            ; so ein scheiss

           ;
           ; void pcibios(XREGS *in, XREGS *out);

	   PUBLIC C pcibios
pcibios    PROC
	   pushad
	   pushfd
	   push bp
	   mov  bp,sp

	   les  bx,[bp + 2 + 32 + 4 +  2]  ; es:bx zeigt auf input
	   mov  eax,es:[bx + _EAX]
	   mov  ecx,es:[bx + _ECX]
	   mov  edx,es:[bx + _EDX]
	   mov  esi,es:[bx + _ESI]
	   mov  edi,es:[bx + _EDI]
	   mov  ebx,es:[bx + _EBX]     ; danach ist bx zerstoert

	   int  01Ah

	   push ebx                    ; ebx sonderbehandeln
	   xor  ebx,ebx
	   les  bx,[bp + 2 + 32 + 4 + 2 + 4]  ; es:bx zeigt auf output
	   mov  es:[bx + _EAX],eax
	   mov  es:[bx + _ECX],ecx
	   mov  es:[bx + _EDX],edx
	   mov  es:[bx + _ESI],esi
	   mov  es:[bx + _EDI],edi

	   pushf                       ; die flags uebernehmen
	   pop  ax
	   mov  es:[bx + _flag],ax
	   and  ax,1                   ; das carry-flag ausloesen
	   mov  es:[bx + _cflag],ax

	   pop  eax      	       ; anstatt ebx: tricky ebx gerettet
	   mov  es:[bx + _EBX],eax

	   pop bp
	   popfd
	   popad
	   ret
pcibios    ENDP

	   ;
	   ; unsigned long readlong(unsigned long far *adresse)
	   ;
	   PUBLIC C readlong
readlong   PROC
	   push bp
	   mov  bp,sp
	   push bx
	   les  bx,[bp + 2 + 2]  ;bx, bp, near return adresse
	   mov  eax,es:[bx]
	   mov  edx,eax
	   shr  edx,16               ; rueckgabe in dx:ax
	   pop  bx
	   pop  bp
	   ret
readlong   ENDP

	   ;
	   ; void writelong(unsigned long far *adresse, unsigned long wert)
	   ;
	   PUBLIC C writelong
writelong  PROC
	   push bp
	   mov  bp,sp
	   push eax
	   push bx
	   les  bx,[bp + 2 + 2]
	   mov  eax,[bp + 2 + 2 + 4]
	   mov  es:[bx],eax
	   pop  bx
	   pop  eax
	   pop  bp
	   ret
writelong  ENDP


	   ;
	   ; void movelong(unsigned long far *nach, 
           ;                  unsigned long far *von, 
	   ;                      unsigned long anzahl);
	   ;
	   PUBLIC C movelong 
movelong   PROC
	   push bp
	   mov  bp,sp
	   push ecx
	   push esi
           push edi           
           push ds
           pushf

	   les  di,[bp + 2 + 2]        ; es:di enthaelt 'nach'
	   lds  si,[bp + 2 + 2 + 4]    ; ds:si enthaelt 'von'
	   mov  ecx,[bp + 2 + 2 + 8]   ; cx enthaelt die 'anzahl'
	   cld                    ; direction auf aufsteigend

	   rep movsd              ; kopieren so schnell es geht

	   popf
	   pop  ds
	   pop  edi
	   pop  esi
	   pop  ecx
	   pop  bp
	   ret
movelong   ENDP

	   ;
	   ; void moveword(unsigned int far *nach,
	   ;                  unsigned int far *von,
	   ;                      unsigned long anzahl);
	   ;
	   PUBLIC C moveword
moveword   PROC
	   push bp
	   mov  bp,sp
	   push ecx
	   push esi
	   push edi
	   push ds
	   pushf

	   les  di,[bp + 2 + 2]        ; es:di enthaelt 'nach'
	   lds  si,[bp + 2 + 2 + 4]    ; ds:si enthaelt 'von'
	   mov  ecx,[bp + 2 + 2 + 8]   ; cx enthaelt die 'anzahl'
	   cld                    ; direction auf aufsteigend

	   rep movsw              ; kopieren so schnell es geht

	   popf
	   pop  ds
	   pop  edi
	   pop  esi
	   pop  ecx
	   pop  bp
	   ret
moveword   ENDP


	   ;
	   ; void movebyte(unsigned char far *nach,
	   ;                  unsigned char far *von,
	   ;                      unsigned long anzahl);
	   ;
	   PUBLIC C movebyte
movebyte   PROC
	   push bp
	   mov  bp,sp
	   push ecx
	   push esi
	   push edi
	   push ds
	   pushf

	   les  di,[bp + 2 + 2]        ; es:di enthaelt 'nach'
	   lds  si,[bp + 2 + 2 + 4]    ; ds:si enthaelt 'von'
	   mov  ecx,[bp + 2 + 2 + 8]   ; cx enthaelt die 'anzahl'
	   cld                    ; direction auf aufsteigend

	   rep movsb              ; kopieren so schnell es geht

	   popf
	   pop  ds
	   pop  edi
           pop  esi
           pop  ecx
	   pop  bp
	   ret
movebyte   ENDP

	   END
