#ifndef __PCIBIOS_H__
//-------------------------------------------------------------------------
//
// pcibios support functions - basic PCI bios functions
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     23.10.1997
//

/* die aufruf codes -----------------------------------------------------*/
#define PCI_FUNCTION_ID             0xB1

#define PCI_PCI_BIOS_PRESENT        0x01
#define PCI_FIND_PCI_DEVICE         0x02
#define PCI_FIND_PCI_CLASS_CODE     0x03
#define PCI_GENERATE_SPECIAL_CYCLE  0x06
#define PCI_READ_CONFIG_BYTE        0x08
#define PCI_READ_CONFIG_WORD        0x09
#define PCI_READ_CONFIG_DWORD       0x0A
#define PCI_WRITE_CONFIG_BYTE       0x0B
#define PCI_WRITE_CONFIG_WORD       0x0C
#define PCI_WRITE_CONFIG_DWORD      0x0D
#define PCI_GET_IRQ_ROUTING_OPTIONS 0x0E
#define PCI_SET_PCI_IRQ             0x0F

/* die return code ------------------------------------------------------*/
#define PCI_SUCCESSFUL          0
#define PCI_FUNC_NOT_SUPPORTED  0x81
#define PCI_BAD_VENDOR_ID       0x83
#define PCI_DEVICE_NOT_FOUND    0x86
#define PCI_BAD_REGISTER_NUMBER 0x87
#define PCI_SET_FAILED          0x88
#define PCI_BUFFER_TOO_SMALL    0x89

/* die funktions prototypen ---------------------------------------------*/
extern char *interpret_error(int error_code);
extern int  pcibios_present(int *major, int *minor,
			      int *bus_number, int *mechanism);
extern int  find_pci_device(int device_id, unsigned short vendor_id, int index,
			     int *bus_number, int *device_number,
			       int *function_number);
extern int find_pci_class_code(unsigned long class_code, int index,
				 int *bus_number, int *device_number,
				   int *function_number);
extern int read_configuration_byte(int bus_number, int device_number,
				     int function_number, int register_number,
				       char *result);
extern int read_configuration_word(int bus_number, int device_number,
				     int function_number, int register_number,
				       unsigned short *result);
extern int read_configuration_dword(int bus_number, int device_number,
				      int function_number, int register_number,
					unsigned long *result);
extern int write_configuration_byte(int bus_number, int device_number,
				      int function_number, int register_number,
					char value);
extern int write_configuration_word(int bus_number, int device_number,
				      int function_number, int register_number,
					unsigned short value);
extern int write_configuration_dword(int bus_number, int device_number,
				       int function_number, int register_number,
					 unsigned long value);
extern int get_interrupt_routing_options(unsigned short *irq_bitmap);


#define __PCIBIOS_H__
#endif