#ifndef __PCICHECK_H__
//-------------------------------------------------------------------------
//
// pcibios support functions - resolve some information from PCI bios
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     02.03.1998
// improved - interrupt line added                      AR     08.04.1999
//

typedef struct
{
  unsigned short vendor_id;
  unsigned short device_id;
  unsigned short command;
  unsigned short status;
  unsigned long  class_revision;
  unsigned char  cache_line_size;
  unsigned char  latency_timer;
  unsigned char  header_type;
  unsigned char  bist;
  unsigned long  base[6];
  unsigned long  cardbus_cis_pointer;
  unsigned short subsystem_vendor_id;
  unsigned short subsystem_id;
  unsigned long  expansion_rom_base_address;
  unsigned long  reserved_0;
  unsigned long  reserved_1;
  unsigned char  interrupt_line;
  unsigned char  interrupt_pin;
  unsigned char  min_gnt;
  unsigned char  max_lat;
} PCI_CONFIG_SPACE;

typedef struct
{
  unsigned long  physical_address;
  unsigned long  physical_range;
  int            prefetchable;
  int            io_space;
} PCI_SPACE;

typedef struct
{
  int       spaces;
  PCI_SPACE loc[6];
} PCI_ADDRESS;

typedef struct
{
  int i;
  int bus_number;
  int device_number;
  int function_number;
  int interrupt_line;
  PCI_ADDRESS pciadr;
} PCIDEV;

//--------- prototypes ------------------------------------------
extern int  pci_get_configuration_space(int bus_number, int device_number,
					int function_number,
					  PCI_CONFIG_SPACE *config_space);
					  // *size muss >= 600 byte sein
extern void type_config_space(PCI_CONFIG_SPACE *c_s, char *buffer, int *size);

extern int  resolve_address(int bus_number, int device_number,
			     int function_number,
			       PCI_ADDRESS *pci_address);
extern int resolve_IRQ_line(int bus_number, int device_number,
			     int function_number, int *IRQ_line);
#define __PCICHECK_H__
#endif