#ifndef __XREGS_H__
//-------------------------------------------------------------------------
//
// defines for long registers realized in assembler
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     22.03.99
//

typedef struct
{
  unsigned long  EAX;
  unsigned long  EBX;
  unsigned long  ECX;
  unsigned long  EDX;
  unsigned long  ESI;
  unsigned long  EDI;
  unsigned short cflag;
  unsigned short flag;
} LREGS;

typedef struct
{
  unsigned short AX;
  unsigned short :16;
  unsigned short BX;
  unsigned short :16;
  unsigned short CX;
  unsigned short :16;
  unsigned short DX;
  unsigned short :16;
  unsigned short SI;
  unsigned short :16;
  unsigned short DI;
  unsigned short :16;
  unsigned short cflag;
  unsigned short flag;
} WREGS;

typedef struct
{
  unsigned char  AL;
  unsigned char  AH;
  unsigned short :16;
  unsigned char  BL;
  unsigned char  BH;
  unsigned short :16;
  unsigned char  CL;
  unsigned char  CH;
  unsigned short :16;
  unsigned char  DL;
  unsigned char  DH;
  unsigned short :16;
  unsigned short :16;
  unsigned short :16;
  unsigned short :16;
  unsigned short :16;
  unsigned short cflag;
  unsigned short flag;
} BREGS;

typedef union
{
  LREGS l;
  WREGS x;
  BREGS h;
} XREGS;

#define __XREGS_H__
#endif

