//-------------------------------------------------------------------------
//
// all around the VMEMM interface entries for the PCIVME
// interface of ARW Elektronik
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     22.03.99
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <stdio.h>
#include <stdlib.h>
#include <menu.h>
#include <pcibios.h>
#include <pcicheck.h>
#include <pcilib.h>

//-------------------------------------------------------------------------
// DEFINES
//

//-------------------------------------------------------------------------
// TYPDEFS
//

//-------------------------------------------------------------------------
// EXTERNALS
//
extern MN_SHOW_ENTRY status_3[];       // von status_3
extern int status_3_entry(void);
extern PCIDEV *selected_device;        // zeigt auf das aktuelle device

//-------------------------------------------------------------------------
// LOCALS
//

//-------------------------------------------------------------------------
// GLOBALS
//

//-------------------------------------------------------------------------
// FUNCTIONS
//
static int action_patch_bug(void)
{
  PLX9050BugFix(selected_device);
  set_status_zeile("PLX9050 Bug fix done!");
  return 0;
}

static int action_VMEMM_status(void)
{
  mn_show_status("Show VMEMM status (PCIADA view)", status_3_entry, status_3, 0);

  return 0;
}

static int action_enable_access(void)
{
  enable_access_to_VMEMM(selected_device);
  set_status_zeile("Access to VMEMM enabled.");
  return 0;
}

static int action_disable_access(void)
{
  disable_access_to_VMEMM(selected_device);
  set_status_zeile("Access to VMEMM disabled.");
  return 0;
}

static int action_test_connection(void)
{
  if (test_connection_to_VMEMM(selected_device) == PCI_SUCCESSFUL)
    set_status_zeile("Connection test to VMEMM successful");
  else
    set_status_zeile("Connection test to VMEMM failed");
  return 0;
}

static int action_leave(void)
{
  return 1;
}

MN_MENU_ENTRY menu_2[] = {{'b', "Patch the PLX9050 Bug", NULL, action_patch_bug},
			  {'e', "Enable access to VMEMM", NULL, action_enable_access},
			  {'d', "Disable access to VMEMM", NULL, action_disable_access},
			  {'t', "Test connection to VMEMM (pure DOS only)", NULL, action_test_connection},
			  {'s', "Show VMEMM status (pure DOS only)", NULL, action_VMEMM_status},
			  {'q', "Leave menu", NULL, action_leave},
			  { 0 , NULL, NULL, NULL}};

int menu_2_entry(void)
{
  return 0;
}