//-------------------------------------------------------------------------
//
// main frame for the pcilook tool for the PCIVME interface of ARW Elektronik
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     22.03.99
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pcibios.h>
#include <pcicheck.h>
#include <menu.h>
#include <tastatur.h>
#include <screen.h>

//-------------------------------------------------------------------------
// DEFINES
//
#define VERSION "2.1"
#define DATUM   __DATE__

//-------------------------------------------------------------------------
// TYPEDEFS
//

//-------------------------------------------------------------------------
// EXTERNALS
//
extern MN_MENU_ENTRY menu_0[];       // the menu description for menu 0
extern int menu_0_entry(void);       // the entry function for menu 0

//-------------------------------------------------------------------------
// GLOBALS
//
char *progname;                      // the name of this program
int main_version, sub_version;       // the versions of the PCI mechanisms

//-------------------------------------------------------------------------
// LOCALS
//

//-------------------------------------------------------------------------
// FUNCTIONS
//
static void helpmsg(char *progname)
{
  printf("%s:\n", progname);
  printf("A program to evaluate and test the PCIVME interface of ARW Elektronik.\n");
  printf("Version %s of %s.\n\n", VERSION, DATUM);
  printf("usage: %s [-?]\n\n", progname);
  printf("       ? - this help\n");
}


int main(int argc, char *argv[])
{
  int i = 1;
  int anzahl_pci_bus, mechanism;

  progname = argv[0];
  progname += strlen(progname);
  while ((*progname != '\\') && (*progname != ':'))
    progname--;
  progname++;

  //------------------ kommandozeile zerlegen ---------------------------
  while (i < argc)
  {
    if ((*argv[i] == '/') || (*argv[i] == '-'))
      argv[i]++;
    else
    {
      printf("%s: Illegal commandline option \"%s\"!\n", progname, argv[i]);
      exit(-1);
    }

    switch (*argv[i])
    {
      case '?': helpmsg(progname);
		exit(0);
		break;

      default:  printf("%s: Illegal commandline option \"%c\"!\n",
							 progname, *argv[i]);
		exit(-1);
		break;
    }

    i++;
  }

  // pruefen, ob ein pci-bios da ist --------------------------------------
  if (pcibios_present(&main_version, &sub_version,
					&anzahl_pci_bus, &mechanism))
  {
    printf("%s: No PCI-bios found!\n",progname);
    exit(-1);
  }

  // ab in die menufuehrung ----------------------------------------------
  ts_init();
  sc_init();
  mn_menu("Main menu", menu_0_entry, menu_0);
  sc_deinit();
  ts_deinit();

  return 0;
}
