//-------------------------------------------------------------------------
//
// content of first submenu of pcilook for the PCIVME interface of
// ARW Elektronik
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
// what							who    when
// first steps						AR     22.03.99
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <menu.h>

#include <pcibios.h>
#include <pcicheck.h>

//-------------------------------------------------------------------------
// DEFINES
//

//-------------------------------------------------------------------------
// TYPEDEFS
//

//-------------------------------------------------------------------------
// EXTERNALS
//
extern PCIDEV *selected_device;     // zeigt auf ein device


//-------------------------------------------------------------------------
// GLOBALS
//
static unsigned short io_base;
static unsigned short dat;
static unsigned long  cntrl;


//-------------------------------------------------------------------------
// LOCALS
//

//-------------------------------------------------------------------------
// FUNCTIONS
//
unsigned long inpl(unsigned short adr)
{
  unsigned long data;

  data = inpw(adr+2);
  data <<= 16;
  data |= (inpw(adr) & 0xffff);

  return data;
}

void show_0(void)
{
  printf("0x%08lx", inpl(io_base + 0x00));
}

void show_4(void)
{
  printf("0x%08lx", inpl(io_base + 0x04));
}

void show_14(void)
{
  printf("0x%08lx", inpl(io_base + 0x14));
}

void show_18(void)
{
  printf("0x%08lx", inpl(io_base + 0x18));
}

void show_28(void)
{
  printf("0x%08lx", inpl(io_base + 0x28));
}

void show_2c(void)
{
  printf("0x%08lx", inpl(io_base + 0x2c));
}

void show_3c(void)
{
  printf("0x%08lx", inpl(io_base + 0x3c));
}

void show_40(void)
{
  printf("0x%08lx", inpl(io_base + 0x40));
}

void show_4c_vme(void)
{
  printf("%s/%s/%s", (dat & 1)?"enable":"disable", (dat & 2)?"high":"low", (dat & 4)?"active":"inactive");
}

void show_4c_timeout(void)
{
  printf("%s/%s/%s", (dat & 8)?"enable":"disable", (dat & 0x10)?"high":"low", (dat & 0x20)?"active":"inactive");
}

void show_4c_global(void)
{
  printf("%s/%s", (dat & 0x40)?"enable":"disable", (dat & 0x80)?"generated":"idle");
}

void show_50_1(void)
{
  unsigned long i = 0;

  printf("%d%d%d%d.%d%d%d%d.%d%d%d%d.%d%d%d%db", (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0,
						 (cntrl & (1<<i++)) ? 1 : 0);
}

void show_50_2(void)
{
  unsigned long i = 16;

  printf("%d%d%d%d.%d%d%d%d.%d%d%d%d.%d%d%d%db", (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0,
						 (cntrl & (1L<<i++)) ? 1 : 0);
}


MN_SHOW_ENTRY status_1[] = {{"Local Address Space #0", show_0},
			    {"Local Address Space #1", show_4},
			    {"Local Base Address Re-Map #0", show_14},
			    {"Local Base Address Re-Map #1", show_18},
			    {"Local Bus Region Descriptor #0", show_18},
			    {"Local Bus Region Descriptor #1", show_2c},
			    {"Chip Select #0 Base Address", show_3c},
			    {"Chip Select #1 Base Address", show_40},
			    {"Interrupt VME enable/polarity/status", show_4c_vme},
			    {"Interrupt Timeout enable/polarity/status", show_4c_timeout},
			    {"Interrupt global enable/generate", show_4c_global},
			    {"CNTRL [15:00]", show_50_1},
			    {"CNTRL [31:16]", show_50_2},
			    {NULL, NULL}};

int status_1_entry(void)
{
  if (selected_device->pciadr.loc[1].io_space)
  {
    io_base = (unsigned short)selected_device->pciadr.loc[1].physical_address;
    dat     = inpw(io_base + 0x4c);
    cntrl   = inpl(io_base + 0x50);
  }
  else
    set_status_zeile("No configuration registers in loc[1] found!");

  return 0;
}

