//-------------------------------------------------------------------------
//
// status subcode for the pcilook tool for the PCIVME interface
// of ARW Elektronik
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
// what							who    when
// first steps						AR     22.03.99
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <stdio.h>
#include <stdlib.h>
#include <menu.h>
#include <pcibios.h>
#include <pcicheck.h>

//-------------------------------------------------------------------------
// DEFINES
//

//-------------------------------------------------------------------------
// TYPEDEFS
//

//-------------------------------------------------------------------------
// EXTERNALS
//
extern PCIDEV *selected_device;     // zeigt auf ein device

//-------------------------------------------------------------------------
// GLOBALS
//

//-------------------------------------------------------------------------
// LOCALS
//
static PCI_CONFIG_SPACE cs;

//-------------------------------------------------------------------------
// FUNCTIONS
//
static void show_line_0(void)
{
  printf("0x%04x - 0x%04x", cs.device_id, cs.vendor_id);
}

static void show_line_4(void)
{
  printf("0x%04x - 0x%04x", cs.status, cs.command);
}

static void show_line_8(void)
{
  printf("0x%06lx - 0x%02lx", cs.class_revision >> 8, cs.class_revision & 0xff);
}

static void show_line_c(void)
{
  printf("0x%02x - 0x%02x", cs.bist, cs.header_type);
  printf(" - 0x%02x - 0x%02x", cs.latency_timer, cs.cache_line_size);
}

static void show_line_10(void)
{
  printf("0x%08lx", cs.base[0]);
}

static void show_line_14(void)
{
  printf("0x%08lx", cs.base[1]);
}

static void show_line_18(void)
{
  printf("0x%08lx", cs.base[2]);
}

static void show_line_1c(void)
{
  printf("0x%08lx", cs.base[3]);
}

static void show_line_20(void)
{
  printf("0x%08lx", cs.base[4]);
}

static void show_line_24(void)
{
  printf("0x%08lx", cs.base[5]);
}

static void show_line_28(void)
{
  printf("0x%08lx", cs.cardbus_cis_pointer);
}

static void show_line_2c(void)
{
  printf("0x%04x - 0x%04x", cs.subsystem_id, cs.subsystem_vendor_id);
}

static void show_line_30(void)
{
  printf("0x%08lx", cs.expansion_rom_base_address);
}

static void show_line_3c(void)
{
  printf("0x%02x - 0x%02x", cs.max_lat, cs.min_gnt);
  printf(" - 0x%02x - 0x%02x", cs.interrupt_pin, cs.interrupt_line);
}

MN_SHOW_ENTRY status_2[] = {{"Device-id - vendor-id", show_line_0},
			    {"Status - command", show_line_4},
			    {"Class - revision", show_line_8},
			    {"BIST - header - latency - cache-line-size", show_line_c},
			    {"PCI base address 0", show_line_10},
			    {"PCI base address 1", show_line_14},
			    {"PCI base address 2", show_line_18},
			    {"PCI base address 3", show_line_1c},
			    {"PCI base address 4", show_line_20},
			    {"PCI base address 5", show_line_24},
			    {"Cardbus CIS pointer", show_line_28},
			    {"Subsystem-id - subvendor-id", show_line_2c},
			    {"Local PCI rom base address", show_line_30},
			    {"MaxLat - MinGnt - IntPin - IntLine", show_line_3c},
			    {NULL, NULL}};

int status_2_entry(void)
{
  int error;

  error = pci_get_configuration_space(selected_device->bus_number,
				      selected_device->device_number,
				      selected_device->function_number,
				      &cs);

  if (error != PCI_SUCCESSFUL)
    set_status_zeile("Error while reading PCI config-space!");

  return 0;
}