//-------------------------------------------------------------------------
//
// content of 3rd submenu of pcilook for the PCIVME interface of
// ARW Elektronik
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header  is  not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
// 
// what							who    when
// first steps						AR     22.03.99
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <menu.h>

#include <pcibios.h>
#include <pcicheck.h>
#include <pcilib.h>

//-------------------------------------------------------------------------
// DEFINES
//

//-------------------------------------------------------------------------
// TYPEDEFS
//

//-------------------------------------------------------------------------
// EXTERNALS
//
extern PCIDEV *selected_device;     // zeigt auf ein device

//-------------------------------------------------------------------------
// GLOBALS
//

//-------------------------------------------------------------------------
// LOCALS
//
static unsigned short wCNTRL  = 0;
static unsigned short wINTCSR = 0;
static int WordMode;
static int ModuleNo;
static int ModuleType;
static int FPGAVersion;
static int Sysctrl;

//-------------------------------------------------------------------------
// FUNCTIONS
//
static unsigned long inpl(unsigned short adr)
{
  unsigned long data;

  data = inpw(adr+2);
  data <<= 16;
  data |= (inpw(adr) & 0xffff);

  return data;
}

static void dummy(void)
{

}

static void show_CNTRL_8(void)
{
  if ((wCNTRL & 0x80) && (!(wCNTRL & 0x40)))
    printf("%s", (wCNTRL & 0x100) ? "yes" : "no");
  else
    printf("Not initialised");
}

static void show_CNTRL_11(void)
{
  if (!(wCNTRL & 0x600))
    printf("%s", (wCNTRL & 0x800) ? "yes" : "no");
  else
    printf("not initialised");
}

static void show_INTCSR_0(void)
{
  if (!(wINTCSR & 0x02))
    printf("%s", (wINTCSR & 0x01) ? "enabled" : "disabled");
  else
    printf("not initialised");
}

static void show_INTCSR_2(void)
{
  printf("%s", (wINTCSR & 0x04) ? "asserted" : "not asserted");
}

static void show_INTCSR_3(void)
{
  if (!(wINTCSR & 0x10))
    printf("%s", (wINTCSR & 0x08) ? "enabled" : "disabled");
  else
    printf("not initialised");
}

static void show_INTCSR_5(void)
{
  printf("%s", (wINTCSR & 0x20) ? "asserted" : "not asserted");
}

static void show_INTCSR_6(void)
{
  printf("%s", (wINTCSR & 0x40) ? "enabled" : "disabled");
}

static void show_Module_Number(void)
{
  if ((wCNTRL & 0x80) && (!(wCNTRL & 0x40)) && (wCNTRL & 0x100))
    printf("%d", ModuleNo);
  else
    printf("---");
}

static void show_FPGA_Version(void)
{
  if ((wCNTRL & 0x80) && (!(wCNTRL & 0x40)) && (wCNTRL & 0x100))
    printf("%d", FPGAVersion);
  else
    printf("---");
}

static void show_Module_Type(void)
{
  if ((wCNTRL & 0x80) && (!(wCNTRL & 0x40)) && (wCNTRL & 0x100))
    printf("%d", ModuleType);
  else
    printf("---");
}

static void show_WordMode(void)
{
  if ((wCNTRL & 0x80) && (!(wCNTRL & 0x40)) && (wCNTRL & 0x100))
    printf("%s", (WordMode) ? "word-path" : "long-path");
  else
    printf("---");
}

static void show_Sysctrl(void)
{
  if ((wCNTRL & 0x80) && (!(wCNTRL & 0x40)) && (wCNTRL & 0x100))
    printf("%s", (Sysctrl) ? "systemcontroller" : "no systemcontroller");
  else
    printf("---");
}

MN_SHOW_ENTRY status_3[] = {{"Access to VMEMM switched on", show_CNTRL_8},
			    {"VMEMM connected and powered", show_CNTRL_11},
			    {"", dummy},
			    {"PCI IRQ1 enabled", show_INTCSR_0},
			    {"PCI IRQ1 pending", show_INTCSR_2},
			    {"", dummy},
			    {"PCI IRQ2 enabled", show_INTCSR_3},
			    {"PCI IRQ2 pending", show_INTCSR_5},
			    {"", dummy},
			    {"Global PCI Interrupt enable", show_INTCSR_6},
			    {"", dummy},
			    {"VMEMM ModuleNumber", show_Module_Number},
			    {"VMEMM FPGA-Version", show_FPGA_Version},
			    {"VMEMM ModuleType",   show_Module_Type},
			    {"VMEMM WordMode",     show_WordMode},
			    {"VMEMM System-Controller", show_Sysctrl},
			    {NULL, NULL}};

int status_3_entry(void)
{
  unsigned short io_base;

  if (selected_device->pciadr.loc[1].io_space)
  {
    io_base = (unsigned short)selected_device->pciadr.loc[1].physical_address;
    wINTCSR = inpw(io_base + 0x4c);
    wCNTRL  = inpw(io_base + 0x50);

    get_information_about_VMEMM(selected_device, &WordMode,
		       &Sysctrl, &ModuleNo, &FPGAVersion, &ModuleType);
  }
  else
    set_status_zeile("No configuration registers in loc[1] found!");

  return 0;
}

