//-------------------------------------------------------------------------
//
// simple program to init and do something with the PCIVME interface of ARW Elektronik
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and
// modify it unless this header  is  not modified or deleted. No warranty is given that
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what							who    when
// first steps						AR     27.05.1999
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <stdio.h>
#include <process.h>
#include <pcilib.h>

//-------------------------------------------------------------------------
// DEFINES
//
#define MY_VMEMM_NUMBER     2          // the module number of VMEMM example
#define MY_VME_ADDRESS      0x00002000 // any address to get access
#define MY_ADDRESS_MODIFIER 0x39       // any address modifier

//-------------------------------------------------------------------------
// DUNCTIONS
//
int main(void)
{
  PCIVME_INTERFACE  *pcivme_interface;
  unsigned long i;

  printf("A simple program to demonstrate the use of\n");
  printf("the PCIVME interface  from ARW Elektronik.\n");
  printf("Try to init VMEMM number %d.\n", MY_VMEMM_NUMBER);
  
  // Inits the Interface
  pcivme_interface = Init_Interface(MY_VMEMM_NUMBER);

  // was the Init successfull?
  if (pcivme_interface == NULL)
  {
    printf("Can't open interface!\n");
    exit(-2);
  }

  // do what you want with the interface
  for (i = 0; i < 0xFFFF; i++)
    WriteWord(pcivme_interface, MY_VME_ADDRESS, i, MY_ADDRESS_MODIFIER);

  if (GetError(pcivme_interface))
    printf("Bus error occured!\n");  
    
  // de-initialises Interface
  DeInit_Interface(&pcivme_interface);

  return 0;
}
