{ UNIT _PCIVME  for a single PCIVME System / ARW 1998,1999
  Dieser Quelltext ist Public Domain.

  ---
  Interrup Handler ist aus der UNIT UART und an _PCIADA angepasst.
    http://www.fb15.uni-dortmund.de/voelker/tpfaq/tpfaq_34.html
    Unit UART - serielle I/O v3    07/91,08/92,01/93
    by Peter Mandrella, P.Mandrella@HOT.gun.de

  Ein PCIADA kann mit PCIADA_enable_irq fuer Interrupts aktiviert und mit
  PCIADA_disable_irq wieder freigegeben werden. Beim Aktivieren ist die
  PCIADA_Nr (default 0) und die intline-number erforderlich

  Das Deaktivieren ist nicht unbedingt noetig, sondern erfolgt falls
  noetig auch automatisch bei Programmende.
  ---
  Achtung! Der Interrup-Haendler arbeitet nur im DOS-MODE korrekt.
           In einem DOS-Fenster unter Windows95/98 kann es u.U zum
	   Sytemabsturz kommen.

  9.3.99   PCI9050 Address-Error mapping fuer PCI 9050 eingebaut
           siehe PCIVME-CD ...\PCI9050\ERRATA.PDF

  16.3.99  Unit CRT erzeugt bei Pentium II einen Runtime-Error
           Abhilfe: siehe PCIVME-CD ...\DOS\PASCAL\BPPATCH

  22.4.00  search no PCIADA with CC32 configuration
}
    {$B-,R-,S-,V-,F-,I-,A+}

    unit _PCIVME;
    interface
    uses crt,dos,_hexnum;
    {$IFNDEF DPMI}
      const Seg0040 = $40;
    {$ENDIF}

         intcount   : word = 0;
  var    IOBASE,VMEMMBASE            : word;  (* MEMBASE = segment *)
         VICBASE,VECBASE,VMEBASE     : word;
         PHYSADR                     : longint;
         intline                     : byte;
         ARW_SUBSYSTEM_ID            : longint;
         error,adr_pcireg,vector     : byte;
         ch                          : char;

  const  adrvmemm_stat               = $0;       (* offset *)
         adrvmemm_reset              = $4;
         adrvmemm_irqstat            = $4;
         adrvmeadr_reg               = $8;
         adrvmeadr_regh              = $a;

  procedure  rd_9050_pcireg        (var data   : longint;
                                   var error   : byte;
                                   plx_card_nr : byte);
  procedure  PCIADA_on;
  procedure  PCIADA_off;
  procedure  PCIADA_autoread_on;
  procedure  PCIADA_autoread_off;
  procedure  PCIADA_tst                 (i:byte);
  procedure  PCIADA_clr_timeovff;
  procedure  VMEMM_test;
  procedure  VMEMM_init;
  procedure  wr_ispl_stat;
  procedure  wr_ispl_irq;
  procedure  wr_plx_int_reg;

  Type       VMEam     = 0..$3F;
             VMEacces  = (d8,d16,d32,iack);

  Procedure  VME_WR               (vdat  : Longint;
                                   vadr  : LongInt;
		                   am    : VMEam;
                                   acces : VMEacces);

  Procedure VME_RD           (var vdat  : Longint;
                                   vadr  : LongInt;
		                   am    : VMEam;
                                   acces : VMEacces);
  Procedure RD_vector       (var vector : byte);

  Procedure PCIADA_suchen   ( pciada_nr : byte);

  procedure PCIADA_enable_irq;            { PCIADA interrupt aktivieren.}

  procedure PCIADA_disable_irq;   	  { PCIADA interrupt de-aktivieren.}

  implementation  {-----------------------------------------------------}

  const  active     	: boolean = (false);
         intmask     	: byte = $10;
         intcontr2  	: boolean = (false);

  var    oldvector      : pointer;
         exitsave   	: pointer;

  procedure wr32(segm,offs:word; d32:longint); far; external;
  procedure rd32(segm,offs:word; var v:longint); far; external;
  {$L _RW32.OBJ}

  Procedure rd_9050_pcireg;
    var
    regah,rega,plxoffset                                 : byte;
    regdl,regdh,rebp,regsi,regdi,regds,reges             : word;
    regax,regbx,regcx                                    : word;
    regs: Registers;
    begin
     {test ob PCI-BIOS vorhanden?}
    plxoffset := data;
    error := 0;
    regs.ax := $b101;
    with regs do intr($1A,regs);
    with regs do
    begin
      regah := ah;
      regdh := dh;
      regdl := dl;
    end;
    if regah = 1 then  error :=1;
    if error = 0 then
    {test einheiten-ID + hersteller-ID}
    begin
      regs.ax := $b102;
      regs.cx := $9050;
      regs.dx := $10b5;
      regs.si := plx_card_nr;
      with regs do intr($1A,regs);
      with regs do
      begin
        regah := ah; (* CI testten ????? *)
        regbx := bx;
      end;
   end;
    if regah <> 0 then  error := 2;
    if error = 0 then
    begin
    {read lowword}
      regs.ax := $b109;
      regs.bx := regbx;
      regs.di := plxoffset + 2;
      with regs do intr($1A,regs);
      with regs do
      begin
        regax := ax;
        regcx := cx;
      end;
      if regah <> 0 then error := 3;
    end;
    if error = 0 then
    begin data := regcx;
      data := data shl 16;
      {read highword}
      regs.ax := $b109;
      regs.bx := regbx;
      regs.di := plxoffset;
      with regs do intr($1A,regs);
      with regs do
      begin
        regah := ah;
        regcx := cx;
      end;
      if regah <> 0 then error := 3;
      if error = 0 then data := data + regcx;
    end;
   end;

 Procedure wr_9050_pcireg  (var data   : longint;
                             var adr_pcireg   : byte;
                             plx_card_nr : byte);

var regah,rega,plxoffset                                 : byte;
    regdl,regdh,rebp,regsi,regdi,regds,reges             : word;
    regax,regbx,regcx                                    : word;
    regs: Registers;
    begin
   {test einheiten-ID + hersteller-ID}
    begin
      regs.ax := $b102;
      regs.cx := $9050;
      regs.dx := $10b5;
      regs.si := plx_card_nr;
      with regs do intr($1A,regs);
      with regs do
      begin
       regah := ah;
       regbx := bx;
      end;
    end;
    {write lowword}
      regs.ax := $b10c;
      regs.bx := regbx;
      regs.di := adr_pcireg; (* enthaelt adresse beim schreiben *)
      regs.cx := data;
      with regs do intr($1A,regs);
      with regs do
      begin
      regah := ah;
      cx := regcx;
      end;
      data := data shr 16;
      {write highword}
      regs.ax := $b10c;
      regs.bx := regbx;
      regs.di := adr_pcireg + 2;
      regs.cx := data;
      with regs do intr($1A,regs);
      with regs do
      begin
      regah := ah;
      cx := regcx;
      end;
    end;
  procedure   PCIADA_suchen;
  var         data : longint;
              error : byte;
  begin
    (* test ARW SUB-ID *)
    data := $2c;
    rd_9050_pcireg(data,error,pciada_nr); (* PCI-Config.-Reg Adr $2c lesen *)
    ARW_SUBSYSTEM_ID := (data shr 16);
    if (error = 0) and (ARW_SUBSYSTEM_ID = $1167)
    then writeln('PCIADA-V #',pciada_nr,' with VMEMM-configuraton find')
    else
    begin
      if (ARW_SUBSYSTEM_ID <> $1167) and (error = 0)
                   then writeln('PLX9050  #',pciada_nr,' is not a PCIADA Board !!!');
      if error = 1 then writeln('PLX9050  #',pciada_nr,' no PCI-BIOS !!!');
      if error = 2 then writeln('PCIADA-V #',pciada_nr,' with VMEMM-configuration not find');
      if error = 3 then writeln('PLX9050  #',pciada_nr,' not found !!!');
      if error > 1 then
      begin
      writeln('error');
  writeln(chr($07));
  write('press any key to exit:');
  repeat until keypressed; ch := ReadKey;
      halt;
      end;

    end;

    if (error = 0) and (ARW_SUBSYSTEM_ID = $1167)
    then
    begin

(* I/O-ADR read -----------------------------------------------------------------   *)
    (* PLX_IO-adresse lesen *)
    data := $14;
    rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $14 read *)
    IOBASE   := data and $0000fff0;
    if error = 0 then
    begin
      if (IOBASE and $00000080) = $00000000 then
      writeln('PCIADA-V #',pciada_nr,' IOBASE  address         = ',num2hex(IOBASE,4))
      else
      begin
       data := $24;
       rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $24 read *)
       adr_pcireg := $14;
       wr_9050_pcireg(data,adr_pcireg,pciada_nr);(* PCI-Config.-Reg Adr $14 write *)
       data := $14;
       rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $14 read *)
       IOBASE   := data and $0000fff0;
      writeln('PCIADA-V #',pciada_nr,' IOBASE  address         = ',num2hex(IOBASE,4))

     end;
    end
   else
    begin
      writeln('PCIADA-V #',pciada_nr,' not found !');
      writeln(chr($07));
  writeln(chr($07));
  write('press any key to exit:');
  repeat until keypressed;
  halt;
    end;

(* BASE-ADR read -----------------------------------------------------------------   *)
      (* PCI_MEM-adresse lesen / $18=Adrspace 1/$1C= Adrspace 2 *)
      data := $18;
      rd_9050_pcireg(data,error,pciada_nr);(* PCI-Config.-Reg Adr $18 read *)
      PHYSADR := data;
      VMEMMBASE   := data shr 4;
(* test  PCIADA-Coniguration  for VMEMM *)
    if VMEMMBASE = 0 then
    begin
      textcolor(4);
      writeln('PCIADA-V #',pciada_nr,' must by modified for VMEMM');
      textcolor(7);
      writeln(chr($07));
      write('press any key to exit:');
      repeat until keypressed;
      halt;
    end;
      VMEMMBASE   := data shr 4;
      VICBASE   := VMEMMBASE + $40;
      VECBASE   := VMEMMBASE + $80;
      VMEBASE   := VMEMMBASE + $100;
    if error = 0
    then writeln('PCIADA-V #',pciada_nr,' MEMBASE address-segment = ',num2hex(VMEMMBASE,4))
    else
    begin
      writeln('PCIADA-V not found !');
      writeln(chr($07));
      writeln('press any key to exit');
      repeat until keypressed;
      halt;
    end;
(* IRQ read -----------------------------------------------------------------   *)


    (* PLX Interrupt Line lesen *)
    data := $3C;
    rd_9050_pcireg(data,error,pciada_nr); (* PCI-Config.-Reg Adr $3c read *)
    INTLINE   := data and $000000ff;
    if error = 0
    then writeln('PCIADA-V #',pciada_nr,' INTLINE interrupt line  = ',num2hex(INTLINE,2))
    else
    begin
      writeln('error');
      writeln(chr($07));
      writeln(chr($07));
      write('press "enter" to exit:');
    repeat until keypressed;;
    halt;
    end;
  end;
end;

  procedure VMEMM_test;

  var data : word;
  begin
  pciada_on;
    data := portw[IOBASE + $50] and $0800;
    if data = $0800 then
    begin
    if memw[vmemmbase:0] and $1000 = $1000 then
    begin
      pciada_on;
      writeln('VMEMM OK');
      pciada_off;
    end
    else
    begin
      textcolor(4);
      writeln('!!! ERROR PCIADA is not connected with a VMEMM');
      textcolor(7);
      writeln(chr($07));
      write('press any key to exit:');
      repeat until keypressed;
      halt;
    end;
    end
    else
    begin
      writeln('Test POWER and CABLE !');
      writeln(chr($07));
      write('press any key to exit:');
      repeat until keypressed;
      halt;
    end;
  end;
(* -------------------------------------------------------- Enable ATADA *)
  procedure PCIADA_tst(i:byte);
  var data : word;
  begin
    data := portw[IOBASE + $50] and $0800;
    if data <> $0800 then
    begin
      textcolor(4);
      writeln('PCIADA-V #',i,' not connected');
      textcolor(7);
    end
    else
    begin
      pciada_on;
      textcolor(2);
      write('PCIADA-V #', i ,' connected with');
      data := memw[VMEMMBASE:0]; (* Statusregister read *);
      if (data shr 12) = $0001 then write(' VMEMM');
      if (data shr 12) = $0008 then write(' CAMAC-CONTROLLER CC32');
      data := (data and $00F0) shr 4;
      writeln(' ModulNr.:',data);
      textcolor(7);
    end;
  end;
(* -------------------------------------------------------- disable ATADA *)
    procedure pciada_on;
    begin portw[IOBASE + $50] := $4186; end;
(* -------------------------------------------------------- disable ATADA *)
    procedure pciada_off;
    begin portw[IOBASE + $50] := $4086;
    (*  !!!!! add disable interrupt and sysfail *)
     end;
(* -------------------------------------------------------- PCIADA off*)
    procedure pciada_autoread_on;
    begin
      portw[IOBASE + $50] := $4184;
    (*  !!!!! User0 = 0 autoread on *)
    end;
(* -------------------------------------------------------- PCIADA off*)
    procedure pciada_autoread_off;
    begin portw[IOBASE + $50] := $4186;
    (*  !!!!! USER0 = 1 autoread off *)
    end;
(* -------------------------------------------------------- set pcx_intcsr *)
    procedure pciada_intcsr;
    begin portw[IOBASE + $4c] := $0009; end;

(* -------------------------------------------------------- cle timeoverff *)
   procedure PCIADA_clr_timeovff;
   begin
     PCIADA_off;                          (* time-over-ff clear *)
     PCIADA_on;
   end;

(* -------------------------------------------------------- Init VMEMM *)
   Procedure VMEMM_init;
   begin
     PCIADA_off;                       
     PCIADA_intcsr;                       (* intcsr default *)
     PCIADA_on;
     memw[VMEMMBASE:adrvmemm_reset] := $a;  (* global-reset *)
     repeat                        (* wait-loop to VME-Reset finish *)
       mem[VICBASE:$b7] := 0;      (*  write adressmodifier into VIC *)
     until mem[VICBASE:$b7] = 0;
     PCIADA_off;                         
     PCIADA_on;

	(* ------  minimal initialisierung  --------*)

     mem[VICBASE:$a3]  := $3c; (*Timeout = 16 us *)
     mem[VICBASE:$3f]  := $3f; (*enable lirq7 for VME _BERR *)
     mem[VICBASE:$3b]  := $3e; (*enable lirq6 RESET_SWITCH Frontpannel *)
     
     mem[VICBASE:$57]  := $00; (*set local vector to 00000111 by lirq7 *)
			  		       (* or 00000110 by lirq6 *)

	(* ------  optinal initialisierung --------*)

     mem[VICBASE:$03]  := $f8+1; (* VIICR *)

     mem[VICBASE:$07]  := $78+1; (* VICR1 *)
     mem[VICBASE:$0b]  := $78+2; (* VICR2 *)
     mem[VICBASE:$0f]  := $78+3; (* VICR3 *)
     mem[VICBASE:$13]  := $78+4; (* VICR4 *)
     mem[VICBASE:$17]  := $78+5; (* VICR5 *)
     mem[VICBASE:$1b]  := $78+6; (* VICR6 *)
     mem[VICBASE:$1f]  := $78+7; (* VICR7 *)

     mem[VICBASE:$23]  := $f8+0; (* VICR7 *)

     mem[VICBASE:$27]  := $f8+1; (* LICR1 *)
     mem[VICBASE:$2b]  := $f8+2; (* LICR2 *)
     mem[VICBASE:$2f]  := $f8+3; (* LICR3 *)
     mem[VICBASE:$7f]  := $f8+4; (* LICR4 *)
     mem[VICBASE:$37]  := $f8+5; (* LICR5 *)
  				 (* LICR6 is set by minimal ini *)
  				 (* LICR7 is set by minimal ini *)
 
     mem[VICBASE:$43]  := $f8+2; (* ICGS *)
     mem[VICBASE:$47]  := $f8+2; (* ICMS *)

     mem[VICBASE:$4b]  := $e8+6; (* EGICR *)

     mem[VICBASE:$4f]  := $08;   (* ICGS-IVBR ! *)
     mem[VICBASE:$53]  := $0c;   (* ICGS-IVBR ! *)

 				 (* LIVBR is set by minimal ini *)

     mem[VICBASE:$5b]  := $10;   (* EGIVBR *)

     mem[VICBASE:$5f]  := $5f;   (* ICSR *)

     mem[VICBASE:$63]  := $00;   (* ICR0 *)
     mem[VICBASE:$67]  := $00;   (* ICR1 *)
     mem[VICBASE:$6b]  := $00;   (* ICR2 *)
     mem[VICBASE:$6f]  := $00;   (* ICR3 *)
     mem[VICBASE:$73]  := $00;   (* ICR4 *)

     mem[VICBASE:$83]  := $fe;   (* VIRSR *)

     mem[VICBASE:$87]  := $0f;   (* VIVR1 *)
     mem[VICBASE:$8b]  := $0f;   (* VIVR2 *)
     mem[VICBASE:$8f]  := $0f;   (* VIVR3 *)
     mem[VICBASE:$93]  := $0f;   (* VIVR4 *)
     mem[VICBASE:$97]  := $0f;   (* VIVR5 *)
     mem[VICBASE:$9b]  := $0f;   (* VIVR6 *)

     mem[VICBASE:$a3]  := $3c;   (* TTR *)
     mem[VICBASE:$b3]  := $40;   (* ARCR *)
     mem[VICBASE:$b7]  := $29;   (* AMSR *)
     mem[VICBASE:$d3]  := $00;   (* RCR *)

     mem[VICBASE:$7f]  := $80; (*reset sysfail / last command by initial*)

  end;

   procedure writebit(data:word);
   var i : integer;
   begin
     for i := 1 to 16 do
     begin
       if (data and $8000) = $8000 then write(' 1  ') else write(' 0  ');
       data := data shl 1;
     end;
     writeln;
   end;
    (* -------------------------------------------------------- Enable ATADA *)
   procedure wr_ispl_stat;
   var data : integer;
   begin
      write('MT3 MT2 MT1 MT0 SV3 SV2 SV1 SV0 NR3 NR2 NR1 NR0 SCO WRD BTL RMC');
      writeln (' vmemm_stat');
      data := memw[VMEMMBASE:adrvmemm_stat];
      writebit(data)
   end;
    (* -------------------------------------------------------- Enable ATADA *)
   procedure wr_ispl_irq;
   var data : integer;
   begin
     write(' -   -   -   -   -   -   -   -   -   -   -   -  IP2 IP1 IP0 INT');
     writeln (' vmemm_irqstat');
     data := memw[VMEMMBASE:adrvmemm_irqstat];
     writebit(data)
   end;
   (* ------------------------------------------------------ Enable ATADA *)
   procedure wr_plx_int_reg;
   var data : integer;
   begin
     write(' -   -   -   -   -   -   -   -  SI1 IEN I2S I2P I2E I1S I1P I1E');
     writeln (' plx_int_reg');
     data := portw[IOBASE + $4c];
     writebit(data)
    end;
   (* ------------------------------------------- clear error-FF on ITVME *)
  Procedure VME_WR;
  begin
    if acces = d8 then
    begin
      mem[VICBASE:$b7] := am;             (*  write adressmodifier into VIC *)
      wr32(VMEMMBASE,$8,vadr);           (* !!! segment,offset,data !!! *)
      mem[VMEBASE:(vadr and $0fff)] := vdat; (* reset  error *)
    end;
    if acces = d16 then
    begin
      mem[VICBASE:$b7] := am;     (*  write adressmodifier into VIC *)
      wr32(VMEMMBASE,$8,vadr);
      memw[VMEBASE:(vadr and $0ffe)] := vdat; (* reset  error *)
    end;
    if acces = d32 then
    begin
      mem[VICBASE:$b7] := am;     (*  write adressmodifier into VIC *)
      wr32(VMEMMBASE,$8,vadr);
      wr32(VMEBASE,vadr and $00000ffc,vdat);
    end;
  end;
  (* ------------------------------------------------------------ read VME *)
  Procedure VME_RD;
  begin
    if acces = d8 then
    begin
      mem[VICBASE:$b7] := am;     (*  write adressmodifier into VIC *)
      wr32(VMEMMBASE,adrvmeadr_reg,vadr);
      vdat := mem[VMEBASE:(vadr and $0fff)]; (* reset  error *)
    end;
    if acces = d16 then
    begin
      mem[VICBASE:$b7] := am;     (*  write adressmodifier into VIC *)
      wr32(VMEMMBASE,adrvmeadr_reg,vadr);
      vdat := memw[VMEBASE:(vadr and $0ffe)]; (* reset  error *)
    end;
    if acces = d32 then
    begin
      mem[VICBASE:$b7] := am;     (*  write adressmodifier into VIC *)
      wr32(VMEMMBASE,adrvmeadr_reg,vadr);
      rd32(VMEBASE,(vadr and $0ffc),vdat);
    end;
  end;
  (* ---------------------------------------------------------- read VME *)
  Procedure RD_vector;
    var intcsr,vmemm_irqstat : word;
    begin
      vector := $00;
      intcsr := portw[IOBASE + $4c];
      (*  writeln(num2hex(intcsr,2));   *)
      if (intcsr and $0020) = $0020 then (* test int2 *)
      begin
        vector := $01; (* int2 detect > vector to $01 *)
        pciada_off;    (* reset int2 *)
        pciada_on;     (* reset int2 *)
      end
      else
      begin
        if (intcsr and $0004) = $0004 then (* test int1 *)
        begin
          vmemm_irqstat := memw[VMEMMBASE:adrvmemm_irqstat];
          vector  := mem[VECBASE:vmemm_irqstat]; (* read vector *)
        end
      end;
    end;
    {--- Interrupt-Handler -----------------------------------------------}
    procedure PCIADA0service  ; interrupt;
    begin
      portw[IOBASE + $4c] := $0009;  		(* disable PCIATA interrupt by PLX_Chip *)
      if intcontr2 then port[$a0]:=$20;
      port[$20]:=$20; 				(* Interrupt-Controller resetten *)
      inc(intcount);
  {   writeln('*',intcount);   }	        (* use by test only  *)
      PCIADA_off;
      PCIADA_on;
      portw[IOBASE + $4c] := $0049;  		(* enable PCIATA interrupt by PLX_Chip *)
    end;

    procedure clearstatus;
    begin
      if intcontr2
      then port[$a0]:=$20;
      port[$20]:=$20;
    end;

    function IntNr:byte;
    begin
      if intline <8 then IntNr:=intline + 8
      else IntNr := intline + $68;
    end;

    procedure PCIADA_enable_irq;
    var p : pointer;
        i : byte;
    begin
      if (intline = 0) or (intline > 15) then
      begin
        writeln('Intline ',intline,'not supported!');
        writeln(chr($07));
        write('press any key to exit:');
        repeat until keypressed;
        exit;
      end;
      if active then
      begin
        writeln('PCIADA-V is aktivated!');
        writeln(chr($07));
        write('press any key to exit:');
        repeat until keypressed;
        exit;
      end;
      active:=true;
      intcount := 0;
      intmask := (1 shl (intline and 7));
      intcontr2 := (intline>7);                (* 2. Interrupt-Controller  *)
      getintvec(IntNr,oldvector);              (* save old vector *)
      setintvec(IntNr,@PCIADA0service);
      if intcontr2
      then port[$a1]:=port[$a1] and (not intmask)  (* enable interrupt by controller *)
      else port[$21]:=port[$21] and (not intmask);
      clearstatus;
      portw[IOBASE + $4c] := $0049;                (* enable PCIATA interrupt by PLX_Chip *)
    end;

    procedure PCIADA_disable_irq;
    begin
      if active then
      begin
        active:=false;
        portw[IOBASE + $4c] := $0009; 	           (* disable PCIATA interrupt by PLX_Chip *)
        if intcontr2
        then port[$a1]:=port[$a1] or intmask       (* disable interrup by controller *)
        else port[$21]:=port[$21] or intmask;
        setintvec(IntNr,oldvector);
        clearstatus;
      end;
    end;
    { Exit-Prozedur }

    {$F+}
    procedure comexit;
    var i : byte;
    begin
    i := 0;
          PCIADA_disable_irq;
      exitproc:=exitsave;
    end;
    {$F-}

    begin
      exitsave:=exitproc;
      exitproc:=@comexit;
    end.
