#ifndef __PCIVME_I_H__
#define __PCIVME_I_H__

//-------------------------------------------------------------------------
// WINNT driver for PCIVME interface from ARW Elektronik, Germany ---------
// the header file to pcivme_i.c - all around interrupt handling
//
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what                                            who          when
// started                                         AR           15.06.99
//

//-------------------------------------------------------------------------
// INCLUDES
//
#include <ntddk.h>
#include <pcivme_drv.h>

//------------------------------------------------------------------------
// DEFINES
//

//------------------------------------------------------------------------
// PROTOTYPES
//
void globalInterruptEnable(PCIADA *pciada);
void globalInterruptDisable(PCIADA *pciada);
NTSTATUS PCIVMETranslateInterrupt(PDEVICE_OBJECT device_Obj);
NTSTATUS PCIVMEConnectInterrupt(PDEVICE_OBJECT device_Obj);
NTSTATUS PCIVMEDisConnectInterrupt(PDEVICE_OBJECT device_Obj);


/* release all this procedures after init of the driver */
#ifdef ALLOC_PRAGMA
#pragma alloc_text (init, PCIVMEConnectInterrupt)
#pragma	alloc_text (init, PCIVMETranslateInterrupt)
#endif

/* put all this procedures in the paged memory-pool, all called at passiv Level */
#ifdef ALLOC_PRAGMA
#pragma alloc_text (page, PCIVMEDisConnectInterrupt)
#endif

#endif //__PCIVME_I_H__
