#ifndef __PCIVMEI_H__
//------------------------------------------------------------------------
// defines, prototypes and more for the interrupt handling
//
// (c) 1999 ARW Elektronik
//
// this source code is published under GPL (Open Source). You can use, redistrubute and 
// modify it unless this header   is not modified or deleted. No warranty is given that 
// this software will work like expected.
// This product is not authorized for use as critical component in life support systems
// wihout the express written approval of ARW Elektronik Germany.
//
// Please announce changes and hints to ARW Elektronik
//
// what                                            who     when
// created                                         AR      01.03.99
// init_irq_descriptor moved from pcivmec.c        AR      01.04.99
//

//------------------------------------------------------------------------
// TYPEDEFS
//
typedef struct
{
  DWORD dwIrqHandle;
  VID   vid;
  DWORD dwIrqHandler;          // pointer to handler funktion
  PTCB  TCB_S;                 // pointer to thread control block
} IRQ_DESCRIPTOR;

//------------------------------------------------------------------------
// PROTOTYPES
//
void  init_irq_descriptor(IRQ_DESCRIPTOR descriptor[], int count);
void  EnableIRQ(void *pvLCR);
void  DisableIRQ(void *pvLCR);
void  ClearIRQ2(void *pvLCR);
WORD  whichIRQ(void *pvLCR);
DWORD dwReadIrq1Src(VPCIVMED_STATIC_STATUS *psVss);
BOOL  Disable_Phys_IRQ(VPCIVMED_STATIC_STATUS *psVss);
BOOL  Enable_Phys_IRQ(VPCIVMED_STATIC_STATUS *psVss);
DWORD get_vector_level(VPCIVMED_STATIC_STATUS *psPCIss,
                        VPCIVMED_VECTOR_COMMAND *psVc,
                          VPCIVMED_VECTOR_LEVEL *psPCIvl, DWORD *pdwLen);

//------------------------------------------------------------------------
// PROTOTYPES
//
extern IRQ_DESCRIPTOR   sIrqDesc[VPCIVMED_MAX_PCIADA];

#define __PCIVMEI_H__
#endif
