;;------------------------------------------------------------------------
;; PCIVMEA.asm - assembler part of the pcivme driver of ARW Elektronik
;;
;; (c) 1999 ARW Elektronik
;;
;; this source code is published under GPL (Open Source). You can use, redistrubute and 
;; modify it unless this header   is not modified or deleted. No warranty is given that 
;; this software will work like expected.
;; This product is not authorized for use as critical component in life support systems
;; wihout the express written approval of ARW Elektronik Germany.
;;
;; Please announce changes and hints to ARW Elektronik
;;
;; what                                                  who     when
;; first release                                         AR      22.03.1999
;;
name PCIVMEA
.386p
;; ------------------------------------------------
;; ------------------------------------------------
;; PCIVMEA.asm -- Assembly module, MAIN module for
;; Dynamically loadable VxD for PCIVME board
;; ------------------------------------------------
;; ------------------------------------------------

;; -----------------------------------
;; INCLUDE files needed by this module
;; -----------------------------------

include <vmm.inc>
include <vwin32.inc>
include <debug.inc>

;; ------------------------------------
;; C routines/data used by this module
;; ------------------------------------
extrn _CheckAndSetPage:near

;; -------------------------------------
;; Routines/data called from this module
;; -------------------------------------
public _HookInvalidPageFault

;; ==============================================================================
VPCIVMED_MajoREV  equ 1       ;PCIVME's MAJOR revision level
VPCIVMED_MinoREV  equ 1	      ;decimal number of revision
VPCIVMED_DeviceID equ Undefined_Device_ID ;no need for MS device number assignment
;;===============================================================================

;; ---------------------------------------------
;; Virtual Device Declaration (Required)
;; (Declares this code as virtual device driver)
;; Also creates the Device Data Block
;; ---------------------------------------------
 
Declare_Virtual_Device VPCIVMED,\
                       VPCIVMED_MajoREV,\
                       VPCIVMED_MinoREV,\
                       VPCIVMED_Control,\
                       VPCIVMED_DeviceID,\
                       Undefined_Init_Order


VxD_LOCKED_CODE_SEG
;; --------------------------------------------
;; Control Dispatch Table & Proc
;; Used to dispatch supported messages sent by
;; VMM -- clears carry for unsupported mssgs.
;; --------------------------------------------

BeginProc VPCIVMED_Control
    Control_Dispatch Sys_Dynamic_Device_Init, CVPCIVMED_Device_Init,   sCall
    Control_Dispatch Sys_Dynamic_Device_Exit, CVPCIVMED_Device_UNInit, sCall
    Control_Dispatch W32_DeviceIoControl,     CVPCIVMED_Device_IOctrl, sCall, <ecx, esi>
    clc          ;;clear carry flag for GOOD indicator   
    ret
EndProc VPCIVMED_Control

;; ======================================================
;; Routines below are miscellaneous assembly interfaces
;; ======================================================

;------------------------
; HookInvalidPageFault_Callback
;------------------------
BeginProc HIPF_Callback

          push edi
          call _CheckAndSetPage 
          pop  edi
          
          cmp  eax,0      ; auf das carry kommt es an
          jz   hi0
          clc  
          jmp  hi1

hi0:      stc
hi1:      ret
EndProc   HIPF_Callback

;---------------------
; BOOLEAN HookInvalidPageFault(void)
;---------------------
BeginProc _HookInvalidPageFault
          push    esi
          mov     esi,OFFSET32 HIPF_Callback
          VMMcall Hook_Invalid_Page_Fault
          jc      ho0
          xor     eax,eax
          jmp     ho1

ho0:      mov     eax,1

ho1:      pop     esi
          ret
EndProc   _HookInvalidPageFault

;---------------------
; void UnhookInvalidPageFault(void)
;---------------------
BeginProc _UnhookInvalidPageFault,PUBLIC
          push    esi
          mov     esi,OFFSET32 HIPF_Callback
          VMMcall Unhook_Invalid_Page_Fault
          pop     esi
          ret
EndProc   _UnhookInvalidPageFault

;---------------------
; inpd, outpd
;---------------------
BeginProc ___inpd,PUBLIC
          mov     dx,word ptr [esp+4]
          in      eax,dx
          ret
EndProc   ___inpd

BeginProc ___outpd,PUBLIC
          mov     dx,word ptr [esp+4]
          mov     eax,dword ptr [esp+8]
          out     dx,eax
          ret
EndProc   ___outpd


VxD_LOCKED_CODE_ENDS

        END


;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------

