#ifndef ARWVME_H
#define ARWVME_H

#include <linux/vme.h>
#include <linux/arwvme.h>
#include <signal.h>
#include <sys/time.h>

#ifndef TRUE
#define FALSE 0
#define TRUE !FALSE
#endif

#ifndef NEW
#define NEW(a) (a *)malloc(sizeof(a))
#endif

char *ArwvmeGetVersionString(void);
int ArwvmeOpen(int module);
int ArwvmeCheckConnection(int fd);
int ArwvmeShutdown(int fd);
int ArwvmeSetMode(int fd, unsigned int mask);
ssize_t ArwvmeRead(int fd, void *buf, size_t count);
ssize_t ArwvmeWrite(int fd, void *buf, size_t count);
ArwvmeSysErrInfo *ArwvmeGetSysErrInfo(int fd);
int ArwvmeCheckSysError(int);
int ArwvmeSelect(int fd, struct timeval *timeout);
ArwvmeIntAck *ArwvmeGetNextPendingInt(int fd);
int ArwvmePostInterrupt(int fd, ArwvmeAckType at, unsigned int rora_reg,
                       int vec , unsigned int acc_mask);
int ArwvmeRemoveInterrupt(int fd, int vec);
int ArwvmeEnableInterrupt(int fd);
int ArwvmeDisableInterrupt(int fd);
int ArwvmeSignal(int fd, void (*sig_handler)(int));
int ArwvmeUntieFpos(int fd);
int ArwvmeTieFpos(int fd);
int ArwvmeSetVmeWindow(int fd, unsigned int addr);
void *ArwvmeMMap(int fd, int size);
int ArwvmeCtrlArbiter(int, ArwvmeArbModes, int, int);
int ArwvmeSetVMEbusTO(int, int);

/* only for superuser or group members of the device (if any) */
int ArwvmeResetVme(int fd);
int ArwvmeInitialize(int fd);

#endif

