
/*
 * File   : arwvme.h
 *
 * Purpose: Header file for arwvme.c, arwvme_simple.c
 *
 * $Revision: 1.15 $
 * $Date: 1999/12/14 16:32:04 $
 * $Id: arwvme.h,v 1.15 1999/12/14 16:32:04 mathes Exp $
 *
 */


#ifndef ARWVME_H
#define ARWVME_H

#include <linux/vme.h>
#include <linux/arwvme.h>
#include <signal.h>
#include <sys/time.h>

#ifndef TRUE
# define FALSE 	0
# define TRUE 	1
#endif

#ifndef NEW
# define NEW(a) (a *)malloc(sizeof(a))
#endif

#ifndef ARWVME_DEFAULT_MODULE
# define ARWVME_DEFAULT_MODULE     2
#endif

typedef struct _ArwvmeDesc
 {
  volatile void  *addr;
  int            acc;
  int            device_fd;

} ArwvmeDesc;

extern char *ArwvmeGetVersionString ( void );

extern int ArwvmeOpen ( int module );
extern int ArwvmeCheckConnection ( int fd );
extern int ArwvmeShutdown ( int fd );

extern int ArwvmeSetMode ( int fd, unsigned int mask );
extern ssize_t ArwvmeRead ( int fd, void *buf, size_t count );
extern ssize_t ArwvmeWrite ( int fd, void *buf, size_t count );
extern ArwvmeSysErrInfo *ArwvmeGetSysErrInfo ( int fd );
extern int ArwvmeCheckSysError ( int );

/* --- interrupt handling --- */

extern int ArwvmeSelect ( int fd, struct timeval *timeout );
extern ArwvmeIntAck *ArwvmeGetNextPendingInt ( int fd );
extern int ArwvmeRegisterInterrupt ( int fd, ArwvmeAckType at, 
                       unsigned int rora_reg, int vec , unsigned int acc_mask );
#define ArwvmePostInterrupt(_fd,_at,_reg,_vec,_acc)\
		ArwvmeRegisterInterrupt(_fd,_at,_reg,_vec,_acc)
extern int ArwvmeUnregisterInterrupt ( int fd, int vec );
#define ArvwmeRemoveInterrupt(_fd,_vec)\
		ArvwmeUnregisterInterrupt(_fd,_vec)
extern int ArwvmeEnableInterrupt ( int fd );
extern int ArwvmeDisableInterrupt ( int fd );
extern int ArwvmeSignal ( int fd, void (*sig_handler)(int) );

extern int ArwvmeUntieFpos ( int fd );
extern int ArwvmeTieFpos ( int fd );
extern int ArwvmeSetVmeWindow(int fd, unsigned int addr);
extern void *ArwvmeMMap(int fd, int size);
extern int ArwvmeCtrlArbiter(int, ArwvmeArbModes, int, int);
extern int ArwvmeSetVMEbusTO(int, int);

/* --- only for superuser or group members of the device (if any) --- */

extern int ArwvmeResetVme ( int fd );
extern int ArwvmeInitialize ( int fd );

/* --- arwvme_simple.c--- */

extern int ArwvmeDefaultDevice;
extern int ArwvmeSimpleOpen ( void );

extern unsigned char ArwvmeReadChar ( ArwvmeDesc *vme );
extern void ArwvmeWriteChar ( ArwvmeDesc *vme, unsigned char data );
extern void ArwvmeBlockWriteChar ( ArwvmeDesc *vme, 
                            unsigned char *data, unsigned int count );

extern unsigned short ArwvmeReadShort ( ArwvmeDesc *vme );
extern void ArwvmeWriteShort ( ArwvmeDesc *vme, unsigned short data );
extern void ArwvmeBlockReadShort ( ArwvmeDesc *vme, 
                             unsigned short *data, unsigned int count );
extern void ArwvmeFifoReadShort ( ArwvmeDesc *vme, 
                             unsigned short *data, unsigned int count );

extern unsigned int ArwvmeReadInt ( ArwvmeDesc *vme );
extern void ArwvmeWriteInt ( ArwvmeDesc *vme, unsigned int data );
extern void ArwvmeBlockReadInt ( ArwvmeDesc *vme, 
                             unsigned int *data, unsigned int count );
extern void ArwvmeFifoReadInt ( ArwvmeDesc *vme, 
                             unsigned int *data, unsigned int count );

#endif

