
/*
 * File   : arwpci.h
 *
 * Purpose: PCI definitions for ARWPCI
 *
 * $Id: arwpci.h,v 1.6 1999/10/07 09:17:25 mathes Exp $
 */

#ifndef LINUX_ARWPCI_H
#define LINUX_ARWPCI_H

#include <linux/version.h>
#include <linux/pci.h>

#include "arwvme_priv.h"

#ifndef LinuxVersionCode
# define LinuxVersionCode(v, p, s) (((v)<<16)+((p)<<8)+(s))
#endif

#if LINUX_VERSION_CODE < LinuxVersionCode(2,1,0)
# include <linux/bios32.h>                          /* obsolete */
#endif

typedef struct _PCIConfigHeader
 {
 /* start of PCI Configuration register */
 
 unsigned short device_id, vendor_id;
 unsigned short status, command;
 unsigned short class_code;
 unsigned char rev_id;
 unsigned int unknown1; 
 unsigned int base_address[6]; 
 unsigned int CBSIS;
 unsigned short subsystem_id, subsystem_vendor_id; 
 
 /* end of PCI Configuration register used here */
 
 unsigned char busnr, devnr;
 unsigned char irq;
 int index;

} PCIConfigHeader;

PCIConfigHeader *GetPCIConfigHeader(short, short, unsigned short);

#endif  /* LINUX_ARWPCI_H */

