#ifndef VIC68A_H
#define VIC68A_H

/*
 * Include header for the VMEbus
 * interface controller VIC68a
 * from Cypress 
 * (www.cypress.com)
 */

/*
 * Offsets of the VIC68a chip
 */
#define VIC68_VIICR   0x03
#define VIC68_VICR(i) (0x07+4*(i-1))
#define VIC68_DMASICR 0x23
#define VIC68_LICR(i) (0x27+4*(i-1))
#define VIC68_ICGSICR 0x43 
#define VIC68_ICMSICR 0x47
#define VIC68_EGICR   0x4B
#define VIC68_ICGSVBR 0x4F
#define VIC68_ICMSVBR 0x53
#define VIC68_LIVBR   0x57 
#define VIC68_EGIVBR  0x5B
#define VIC68_ICSR    0x5F
#define VIC68_ICR(i)  (0x63+4*(i))
#define VIC68_VIRSR   0x83
#define VIC68_VIVBR(i) (0x87+4*(i-1))
#define VIC68_TTR     0xA3
#define VIC68_LBTR    0xA7
#define VIC68_BDTR    0xAB
#define VIC68_ARCR    0xB3
#define VIC68_AMSR    0xB7
#define VIC68_BESR    0xBB
#define VIC68_DMASR   0xBF
#define VIC68_RCR     0xD3
#define VIC68_BTCR    0xD7
#define VIC68_BTLR1   0xDB
#define VIC68_BTLR0   0xDF
#define VIC68_SRR     0xE3

/*
 * Bitmasks
 */
#define VIC68_AMSR_MASK    0x3F
#define VIC68_BERR_MASK    0x20
#define VIC68_VMETO_MASK   0x10

#endif
