
/*
 * File   : test_mmap.c
 *
 * Purpose: Test program for ARWVME interface kit
 *          testing the mmap() function with two windows ... 
 *
 *
 * $Revision: 1.1 $
 * $Date: 2000/02/25 16:55:00 $
 * $Id: test_map.c,v 1.1 2000/02/25 16:55:00 mathes Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include <time.h>
#include <sys/times.h>    

#include <arwvme.h>

#define BASE1 0x00FA0000    /* module V462 */
#define BASE2 0x00FC0000    /* module digi-20x */

static int arwvme_fd = -1;

/* -------------------------------------------------------------------------- */

int main ( void )
 {
  struct timeval start, stop;
  struct timezone zone;
  unsigned char *vme;
  int i, dummy;
  
  printf ( "ArwvmeOpen: %d %d\n", arwvme_fd = ArwvmeOpen(2), errno );
  if (arwvme_fd < 0) exit ( EXIT_FAILURE );

  printf ( "ArwvmeCheckConnection: %d\n", ArwvmeCheckConnection(arwvme_fd) );
  
  ArwvmeSetMode(arwvme_fd, 
                ARWVME_A24 | ARWVME_D16 | ARWVME_DATA | ARWVME_NONPRIV);

  vme = ArwvmeMMap ( arwvme_fd, 0x1000 );
  if ( vme )
   {
    ArwvmeSetVmeWindow ( arwvme_fd, BASE1 );
    printf ( "V462 module identifier: 0x%x\n", 0xffff & *((short *)(vme + 0xfa)) );

    ArwvmeSetVmeWindow ( arwvme_fd, BASE2 );
    *((short *)(vme + 0x86)) = 0x0;
    printf ( "DIGI port 3: 0x%x\n", 0xffff & *((short *)(vme + 0x6)) );

    gettimeofday ( &start, &zone );
    for ( i=0; i<512; i++ )
      ;
    gettimeofday ( &stop, &zone );
    printf ( "empty loop: %d usec\n", stop.tv_usec - start.tv_usec +
              (stop.tv_sec - start.tv_sec) * 1000000 );

    gettimeofday ( &start, &zone );
    for ( i=0; i<512; i++ )
      *((short *)(vme + 0x86)) = 0x0;
    gettimeofday ( &stop, &zone );
    printf ( "512 * 2 Bytes write: %d usec\n", stop.tv_usec - start.tv_usec +
              (stop.tv_sec - start.tv_sec) * 1000000 );

    ArwvmeSetVmeWindow ( arwvme_fd, BASE1 );
    gettimeofday ( &start, &zone );
    for ( i=0; i<512; i++ )
      dummy = *((short *)(vme + 0xfa));
    gettimeofday ( &stop, &zone );
    printf ( "512 * 2 Bytes read: %d usec\n", stop.tv_usec - start.tv_usec +
              (stop.tv_sec - start.tv_sec) * 1000000 );
  }
  else
    printf("Sorry, no remap!\n");

  ArwvmeShutdown(arwvme_fd);
  
  exit ( EXIT_SUCCESS );
}

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
